{ This is the input data:
7
5 4 3 2 1 4 4
7 3 4 2 2 4

             ---------------------------------------------
                 - '96
             ---------------------------------------------


 4.     ( 35 )
----------------------------------------
     .        
n <= 200   .       1  ,  
 -     .

   ,    Ti     i- .  
    ,  j  j+1 -  (1 <= j <= n-1)   
       ,     ,  
rj ,      j-  (j+1)-   - 
Ti + T(i+1).  ,         
      ,      
           ,    .

        n , Ti  rj , 
     ,       
 -  .        
       .

   ( INPUT3.TXT):       . 
   n.      -   Ti.
   n-1  -   rj.

   ( OUTPUT3.TXT):         
  ,       .  
       1   2   
 +. -        i, i-  
  ,  i+(i+1),       
 .

                   

7                      14
5 4 3 2 1 4 4          1
7 3 4 2 2 4            2+3
 		       4+5
		       6+7


 :

      .
           
    j- .     
    (j+1)- .

   2 :
  1)  (j+1)     .
  2)  (j+1)       j.

     F ,   F[j]    
 j- .

  F[j] = Max( F[j-1]+T[j] , F[j-2]+R[j-1] );
                        /               \
                       /                 \
                      /                   \
     j               j  a  (j-1)
}

Uses Crt;

Var
 F,OptiumF:array[-5..200] of integer;
 T:array[-1..200] of integer;
 R:array[-1..200] of integer;
 N:integer;

const
 OptiumT:integer = 32000;

procedure ReadIt(S:String);
Var
 F:Text;
 i:integer;
begin
 FillChar(R,SizeOf(R),0);
 FillChar(T,SizeOf(T),0);

 assign(F,S); reset(f); readln(f);
 readln(F,N);
 for i:=1 to N do read(F,T[i]);
 for i:=1 to N-1 do read(F,R[i]);
 close(f);
end;

procedure WriteIt;
Var
 i:integer;
begin
 WriteLn('   :',N);
 Write(' Ti :'); for i:=1 to N do Write(T[i],' '); WriteLn;
 Write(' Rj : '); for i:=1 to N-1 do Write(R[i],' ');
 WriteLn;
end;


procedure Dinamic;
Var
 i:integer;
 Double,Single:integer;
begin
 FillChar(F,SizeOf(F),0);

 F[0]:=0;  F[1]:=T[1];

 OptiumT:=0;

 for i:=2 to N do
  begin
   Double:=F[i-2] + R[i-1];
   Single:=F[i-1] + T[i];

   if Single < Double then
    begin
     F[i]:=Single;
     OptiumT:=Single;
    end
   else
    begin
     F[i]:=Double;
     OptiumT:=Double;
    end;
  end;

 i:=N;
 repeat
  if F[i] = F[i-2] + R[i-1] then
   begin
    OptiumF[i-1]:=i;
    dec(i);
   end
  else
   OptiumF[i]:=i;

  dec(i);
 until i<=0;
end;

procedure Solve;
Var
 i:integer;
 Calced:integer;
begin
 FillChar(F,SizeOF(F),0);

 Dinamic;
 Calced:=0;

 WriteLn(#10#13);
 WriteLn('-  :',OptiumT);
 WriteLN;
 for i:=1 to N do
  if OptiumF[i] = i then
   begin
    WriteLn('(',i,') ');
    inc(Calced,T[i]);
   end
  else
   if OptiumF[i] <> 0 then
    begin
     WriteLn('(',i,'+',OptiumF[i],') ');
     inc(Calced,R[i]);
    end;

 if Calced <> OptiumT then
  begin
   WriteLn(^G^G,'    '^G^G);
   Halt;
  end;
end;

begin
 ClrScr;
 ReadIt('BILETI.PAS');
 WriteIt;
 Solve;
end.


