{ This is the input data:  N;  Beg1 End1;  Beg2 End2;  ...;  BegN EndN;
 11
 1 6
 13 14
 2 4
 4 5
 3 13
 6 7
 4 8
 7 10
 9 12
 6 9
 9 11
                             
                            ----------------

               -   
    ,        -
  .   N    ,     -
     .    ,  -
   ,     .

         :     N      -
       ,        .
      F(x),      -
 ,   -   x    . 
    F(0) = 0
    F(x) = F(x-1)    x     
    F(x) = Max( F(beg-1)+1 )   beg      
                             ,    x
    F(last),  last   ,    -
  .     .
       : ,       
 ,      -,       
  ,     .    -, -
 ,       .    
      ,   .      -
 ,  F(x) = 1  -  x,       
   F(0..x-1)=0.  ,  ,   --
       .         -
   .  ,       .
      ,   ,   -
 ,   .      , -
           .   
   greedy      : -
     ;   ,    - ,
 ,       .      -
   ,     .
            ,   -
  - ,           -
   .        -
 :
     F(x) = Max( F(beg-1)+value )   beg     
      ,    x,   value   
           , 
       ,       
  .     ,    -
     N.logN.        -
          N*N.
}

{$R-,S-,Q-}
CONST MaxN = 1000;
      InFileName  = 'CEN.PAS';
      OutFileName = '';


TYPE TTask = record b,e:integer; end;


VAR N: integer;
    Z: array[1..MaxN] of TTask;


Procedure ReadData; { Read the input data - N, Z[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with Z[N] do
      Read(F,b,e);
  Close(F);
End;


Procedure SortData; { Sort the list of tasks by 'end time' }
  Procedure Swap(var a,b:TTask);
  Var Tmp: TTask;
  Begin Tmp:=a; a:=b; B:=Tmp; End;
Var I,J: integer;
Begin
  for I:= 1 to N-1 do
    for J:= I+1 to N do
      if Z[J].e < Z[I].e then
        Swap(Z[J],Z[I]);
End;


Procedure FindBestShedule; { Find the solution }
Var I, Left, Count: integer;
    OutF: Text;
Begin
  { finding the maximal number of tasks - Count }
  Left:=0; Count:=0;
  for I:= 1 to N do
    if Z[I].b > Left then
      begin Inc(Count); Left:=Z[I].e; end;
  { writing the result }
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,Count);
  Close(OutF);
End;


BEGIN
  ReadData;
  SortData;
  FindBestShedule;
END.
