{    :  I, J, C;   A1, B1, A2, B2, A3, B3;
 1 2  135
 5 11  5 43  30 -25


                              
                             ----------

                
 3 ,    ,    1, 2  3.  -
        (A1,B1), (A2,B2)  (A3,B3).
    ,     J (J=1..3)  
     I (I=1..3,I<>J)  ,     
  I,    K (K=1..3,K<>I,K<>J)   C  (C=0...180).
    ,     ,  -
     .     .   
 I,J  C.   -   - .

     :   :

         (X1,Y1) *
                 
         (X2,Y2) *
                 
                  C
           (X,Y) * * (X3,Y3)

  (X1,Y1)     , (X2,Y2)   
  ,  (X3,Y3)     ,  C   -
         .    
 X  Y.          ,
            I  J.  -
   1 ()  2 ()   
 ,      .      A*x+B*y+C=0.
      2 (X2,Y2)      
 1 (X1,Y1).   ,        
         .    -
    (X2,Y2)    2,   3. 
   -    C,   X X2   Y Y2.  
     ,      -
   2  .        -
       C     ,  -
 . ,      -  C  .   -
   ,         -
 ,      ,    -
     .        ,   -
   .   2       1 -
     2 .       -
   (   X  -     Y).  -
   X2:= X2...    X2  X1  -
   .   0     ,    -
 .     (X2,Y2)     
  -  C   .    ,  , -
        -.     -
   ,  Y2:= Y2...    Y2 -
  X2       .    
 ,  X2 ( Y2)        
     1       2  (. PravaX 
 PravaY).   ,        -
  .  ,       -15000  15000.
}

CONST EndLess = 15001; {      -15000  15000}
      InFileName  = 'NIGHTSEA.PAS';
      OutFileName = '';

VAR X,Y, X1,Y1, X2,Y2, X3,Y3: integer;
    cosGivenAngle: real;


Procedure ReadData; {   - X1,Y1, X2,Y2, X3,Y3,
  cosGivenAngle.  (X1,Y1)    (X2,Y2),  (X3,Y3)  }
Var I,J,K,C: integer;
    X,Y: array[1..3] of integer;
    F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,I,J,C);
  ReadLn(F,X[1],Y[1],X[2],Y[2],X[3],Y[3]);
  Close(F);
  for K:= 1 to 3 do
    if (K<>I) and (K<>J) then Break;
  X1:=X[J]; Y1:=Y[J]; {X1,Y1 -    }
  X2:=X[I]; Y2:=Y[I]; {X2,Y2 -    }
  X3:=X[K]; Y3:=Y[K]; {X3,Y3 -    }
  cosGivenAngle:=cos(C*PI/180); {    }
End;


Procedure UravnenieNaPrava(X1,Y1,X2,Y2:integer; var A,B,C:longint);
Begin
  A:=Y2-Y1;
  B:=X1-X2;
  C:=Y1*X2-X1*Y2;
End;


Function cosAngle(const X1,Y1,X2,Y2,X3,Y3:longint): real;
Var R12,R13,R23: longint;
Begin
  R12:= sqr(X1-X2) + sqr(Y1-Y2);
  R13:= sqr(X1-X3) + sqr(Y1-Y3);
  R23:= sqr(X2-X3) + sqr(Y2-Y3);
  cosAngle:= (R12+R23-R13)/(2*sqrt(R12)*sqrt(R23));
End;


Procedure Find_X_Y;
Var dX,dY: integer;
    A,B,C: longint;
    Mind: real;
    NoMore: boolean;

  Procedure Check(var NoMore:boolean);
  Var d: real;
  Begin
    d:= abs(cosAngle(X1,Y1,X2,Y2,X3,Y3)-cosGivenAngle);
    if d < Mind then
      begin X:=X2; Y:=Y2; Mind:=d; NoMore:=false; end
    else NoMore:=true;
  End;

  Procedure CheckPravaX;
  Begin
    if X1 < X2 then dX:=1
    else dX:=-1;
    repeat
      Y2:= round((-C-A*X2)/B);
      Check(NoMore);
      X2:=X2+dX;
    until (abs(X2) > EndLess) or NoMore;
  End;

  Procedure CheckPravaY;
  Begin
    if Y1 < Y2 then dY:=1
    else dY:=-1;
    repeat
      X2:= round((-C-B*Y2)/A);
      Check(NoMore);
      Y2:=Y2+dY;
    until (abs(Y2) > EndLess) or NoMore;
  End;

Begin
  Mind:=MaxInt;
  UravnenieNaPrava(X1,Y1,X2,Y2,A,B,C);
  dX:=abs(X2-X1); dY:=abs(Y2-Y1);
  if dX > dY then CheckPravaX
  else CheckPravaY;
End;


VAR OutF: Text;

BEGIN
  ReadData;
  Find_X_Y;
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,X,' ',Y);
  Close(OutF);
END.