{
     , 24  2001

 3 ( 11-12 )  Routes

    N  (1 < N < 170),     
 1  N.            .
    , ..       
    .   ,     
      ,    ,   
  , ..        
 .   ROUTES.EXE,    
,         ,   
  .

      ROUTES.INP.      
  N.  N   ,  i-   
      i-        
,     .

        ROUTES.OUT.  
   ,       
,            
  ,    .     
   -  ,        
  .

:

ROUTES.INP

3
1 2
2 1 3
1 2

ROUTES.OUT

1 2
2 3


:

            N
    . ,     
    .

   (         )  
,          
.           
         .   
        
         .
(          ; 
   Data Structures and Algorithms  Aho, Hopcroft  Ullman)

          , 
      - DFSnumber  BACKnumber. ,
   DFSnumber        
 ( N-    DFSnumber   [1,N]   
       DFSnumber). BACKnumber    v 
 :
   * DFSnumber[v]
   * DFSnumber[u]   u,     u-v, u   
   v      v  u
   * BACKnumber[u]   u,     u-v,  u   
    v.

         v 
     1)    DFSnumber  v;
2)        v; 3)   
BACKnumber  v.  , DFSnumber     
   ,  BACKnumber        
.

    1), 2)  3)      
 v      v  u.  u-v   
   DFSNumber[v] = BACKnumber[v].   , 
u-v     ,        
u-v.  , u-v     .

        
   .. O(N+M),  N    ,  M 
  .        
,   -        
 ( )      , 
  .    O(N^2).  M < N^2, 
   O(N^2)     
  .

           :
       
   B    ,   
   UnVis       
   DfsNum, BackNum       -


    ,         
8-9       1997.


--Kristiyan Haralambiev
}

program routes;
const
        InFile                          = 'routes.inp';
        OutFIle                         = 'routes.out';
        MaxN                            = 170;
        Marked                          = 2;
var
        A, B                            : array[1..MaxN,0..MaxN] of Byte;
        DfsNum, BackNum                 : array[1..MaxN] of Byte;
        UnVis                           : array[1..MaxN] of Boolean;
        N, Index                        : Integer;


{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
        Fi                              : Text;
        K, L                            : Integer;
begin
  FillChar(A, SizeOf(A), 0);
  FillChar(B, SizeOf(B), 0);

  Assign(Fi, InFile); ReSet(Fi);

  ReadLn(Fi, N);
  for K := 1 to N do begin
    Read(Fi, B[K,0]);
    for L := 1 to B[K,0] do begin
      Read(Fi, B[K,L]);
      A[K, B[K,L] ] := 1;
    end;
    ReadLn(Fi);
  end;

  Close(Fi);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Dfs(I, Prev : Byte);
var
        J                               : Byte;
begin
  UnVis[I] := False;
  
  Inc(Index);
  DfsNum[I] := Index;
  BackNum[I] := Index;

  for J := 1 to B[I,0] do
    if B[I,J] <> Prev then
      if UnVis[ B[I,J] ] then begin
        Dfs( B[I,J], I);
        if BackNum[ B[I,J] ] < BackNum[I] then BackNum[I] := BackNum[ B[I,J] ];
      end else       {back edge}
        if DfsNum[ B[I,J] ] < BackNum[I] then BackNum[I] := DfsNum[ B[I,J] ];

{ check for articulation edge }
  if BackNum[I] = DfsNum[I] then begin {in the case, '=' is the same as 'not <'}
    A[I, Prev] := Marked;
    A[Prev, I] := Marked;
  end;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
        K                               : Integer;
begin
  FillChar(UnVis, SizeOf(UnVis), 1);
  UnVis[1] := False;
  
  Index := 1;
  DfsNum[1] := Index;

  for K := 1 to B[1,0] do
    if UnVis[ B[1,K] ] then Dfs( B[1,K], 1);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
        Fo                              : Text;
        I, J                            : Integer;
begin
  Assign(Fo, OutFile); ReWrite(Fo);
  for I := 1 to N do
    for J := I+1 to N do
      if A[I,J] = Marked then WriteLn(Fo, I, ' ', J);
  Close(Fo);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.

