{ This is the input data:
D4 A3 A8 H1 H8

            
     1998 .    -, 
     .       -
             -
      .     -
     ,       7  
  "INFOMAN".

                                 
                                 -------

          8 x 8.      
    .       
  ,         -  
     "",  -    .   
  "" .           ,  -
                  
 .             -
              .  -
        .     : -
   ,    ,     ..   
         (  ). 
       .    ,  
         .

     :           -
    ,          -
      .     -
           :  D[x,y,dx,dy]
        (x,y)   (dx,dy)  W[x,y,dx,dy]
        (x,y)   (dx,dy)  , -
        (DestX,DestY).    
 K,           (Xk,Yk),     
   .       ,   -
    K-,      (DestX,DestY)  +   ,
       (Xk,Yk) +  ,    -
    (Xk,Yk) +  ,        
 ,   D[Xk,Yk,DestX,DestY].  Xk, Yk  K    
 .           
               
               -
     .         -
            ,    -
                   -
    .  ,          
             (   
 ,        ,    ).  P[1..N] 
     P[0]    .     -
  :
     Min:=
     for DestX = 1 to 8
       for DestY = 1 to 8
         for K = 1 to N
           for Xk = 1 to 8
             for Yk = 1 to 8
               S:= Sum - D[ P[K], DestX,DestY ]
                       + D[ P[K], Xk,Yk ]
                       + D[ Xk,Yk, DestX,DestY ]
		       + W[ P[0], Xk,Yk )
	       if S < Min then Min:= S
      (Min)
   Sum   D[ P[i], DestX,DestY ]  i=1..N. 
   -  -         -
              
     .       -
     .      ,  
   .         -
    -  D[...]       . 
               
     D.
}


 program Camelot;
 {$A+,B-,D+,E+,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
 {$M 16384,0,655360}

 type
   TCustomHui = array[1..8,1..8] of Integer;

 var
   F : Text;
   S,S1 : String;
   I,Knights,KnightJoin,X,Y : Integer;
   KingX,KingY : Integer;
   KnX,KnY : array[1..64] of Integer;
   KnKur : array[1..64] of TCustomHui;
   KingKur,TotalKur : TCustomHui;
   Moves,BestMoves : Integer;

 procedure WaveHui(var Kur : TCustomHui; StartX,StartY : Integer; IsKing : Boolean);
 var KurNow,KurNext,X,Y : Integer; Flag : Boolean;
   procedure SetPos(X,Y : Integer);
     begin {SetPos}
     if (X>=1) and (Y>=1) and (X<=8) and (Y<=8) and (Kur[X,Y]=-1) then
       begin Kur[X,Y]:=KurNext; Flag:=True; end;
     end;
   begin {WaveHui}
   FillChar(Kur,SizeOf(Kur),$ff); { -1 }
   KurNow:=0; Kur[StartX,StartY]:=KurNow;
   repeat
     Flag:=False; KurNext:=KurNow+1;
     for Y:=1 to 8 do for X:=1 to 8 do if Kur[X,Y]=KurNow then
       if IsKing then
         begin
         SetPos(X-1,Y-1); SetPos(X,Y-1); SetPos(X+1,Y-1);
         SetPos(X-1,Y); SetPos(X+1,Y);
         SetPos(X-1,Y+1); SetPos(X,Y+1); SetPos(X+1,Y+1);
         end
       else
         begin
         SetPos(X-2,Y-1); SetPos(X-1,Y-2); SetPos(X+1,Y-2); SetPos(X+2,Y-1);
         SetPos(X-2,Y+1); SetPos(X-1,Y+2); SetPos(X+1,Y+2); SetPos(X+2,Y+1);
         end;
     KurNow:=KurNext;
   until not Flag;
   end;

 function CalcTotalKur(var Kur : TCustomHui) : Integer;
 var I,MinMoves,X,Y : Integer;
   procedure AddHuiToKur(var Hui : TCustomHui);
   var X,Y : Integer;
     begin {AddHuiToKur}
     for Y:=1 to 8 do for X:=1 to 8 do if Kur[X,Y]<>-1 then
       if Hui[X,Y]=-1 then Kur[X,Y]:=-1 else Inc(Kur[X,Y],Hui[X,Y]);
     end;
   begin {CalcTotalKur}
   FillChar(Kur,SizeOf(Kur),0);
   AddHuiToKur(KingKur); for I:=1 to Knights do AddHuiToKur(KnKur[I]);
   MinMoves:=MaxInt; for Y:=1 to 8 do for X:=1 to 8 do if Kur[X,Y]<>-1 then
     if Kur[X,Y]<MinMoves then MinMoves:=Kur[X,Y]; CalcTotalKur:=MinMoves;
   end;

 procedure JoinKingHuiToKnightKur(var Kur : TCustomHui; JoinX,JoinY : Integer);
 var X,Y,JoinValue,KnightValue,Moves : Integer; TempKnightKur,TempKingKur : TCustomHui;
   begin
   TempKnightKur:=Kur; TempKingKur:=KingKur;
   JoinValue:=KingKur[JoinX,JoinY]; KnightValue:=Kur[JoinX,JoinY];
   WaveHui(Kur,JoinX,JoinY,False);
   for Y:=1 to 8 do for X:=1 to 8 do Inc(Kur[X,Y],KnightValue);
   for Y:=1 to 8 do for X:=1 to 8 do
     begin
     if (Kur[X,Y]<>-1) and (JoinValue<KingKur[X,Y]) then KingKur[X,Y]:=JoinValue;
     end;
   Moves:=CalcTotalKur(TotalKur); if Moves<BestMoves then BestMoves:=Moves;
   Kur:=TempKnightKur; KingKur:=TempKingKur;
   end;

 begin
 Assign(F,'CAMELOT2.PAS'); FileMode:=0; Reset(F); ReadLn(F);
 ReadLn(F,S1); S:='';
 for I:=1 to Length(S1) do if UpCase(S1[I]) in ['1'..'8','A'..'H'] then S:=S+UpCase(S1[I]);
 Knights:=0; KingX:=Byte(S[1])-Byte('A')+1; KingY:=Byte(S[2])-Byte('1')+1; Delete(S,1,2);
 while Length(S)>=2 do
   begin Inc(Knights); KnX[Knights]:=Byte(S[1])-Byte('A')+1; KnY[Knights]:=Byte(S[2])-Byte('1')+1; Delete(S,1,2); end;
 Close(F);
 {}
 BestMoves:=MaxInt;
 for I:=1 to Knights do WaveHui(KnKur[I],KnX[I],KnY[I],False);
 WaveHui(KingKur,KingX,KingY,True);
 { Try no joining: }
 Moves:=CalcTotalKur(TotalKur); if Moves<BestMoves then BestMoves:=Moves;
 { Try joining: }
 for KnightJoin:=1 to Knights do
   begin
   for Y:=1 to 8 do for X:=1 to 8 do if KnKur[KnightJoin][X,Y]<>-1 then
     JoinKingHuiToKnightKur(KnKur[KnightJoin],X,Y);
   end;
 {}
 Assign(F,''{'CAMELOT.OUT'}); FileMode:=2; Rewrite(F);
 WriteLn(F,BestMoves);
 Close(F);
 end.