/*
                              
                            ---------------

            ,    n   
 ,   n +    .      k,
     k.
         480   { 480, 492, 507, 519,... }.
                .   
     ,      .
        480     483  519      507 
 507,        481.

 )            1,   3  
 9.  ,       n (1<=n<=16384) 
 ,   n        .
 :
 : 86
 :     1  101.

 )     - ,         100 -
  .
  8  -   4  :
  1, 2, 4  8

 )   :       .        n
   .      ""  1, 3  9 
    -   .    -,    
 ,        (,        ,
         ,)   . 
     :    O(n^2),    
   ,    .
                                                                 
*/

#include <stdio.h>

int sum( int x )
{
  int a;

  for( a = 0; x; a += x % 10, x /= 10 );

  return a;
}

int main( void )
{
  int flow1 = 1, flow3 = 3, flow9 = 9;
  int i, n;

  scanf( "%d", &n );
  for( i = n;; n += sum( n ) )
  {
    for(; flow1 < n; flow1 += sum( flow1 ) );
    for(; flow3 < n; flow3 += sum( flow3 ) );
    for(; flow9 < n; flow9 += sum( flow9 ) );
    if( flow1 == n )
    {
      printf( "    1  %d\n", flow1 );
      return 0;
    }
    if( flow3 == n )
    {
      printf( "    3  %d\n", flow3 );
      return 0;
    }
    if( flow9 == n )
    {
      printf( "    9  %d\n", flow9 );
      return 0;
    }
  }

  return -1;
}
