{ This is the input data (in format  N;  x1 y1;  x2 y2;   xN yN) :
  6
 0 0
 0 50
 50 50
 50 100
 100 100
 100 0

                              
                            ---------------------

    (      7-    )


            (  -
 ),      N     -
 .            -
  .  ,        ,   -
            . -
        ,  ,   .   -
    ,       (   -
    ).         
 "No solution".

                                 
                                 -------

     ,        
 ,        .   
  .        ,    -
  :
   -    ,       
   -    ,       
   -    ,      
   -    ,      .
       ,       -
   ,       ,       -
          .    (  -
 )     ,     
   ,  ,     .   ,  
   (x1,y1,x2,y2),    ,  (x1=x2)  (y1<y2). 
    .   ,      -
 .       (, , ...)   -
 ,      .       4  -
   (MinX),   (MaxX),   (MinY)   -
  (MaxY).          , 
       ,       ,-
        (MixX,MaxX).    
       ( MinX>MaxX  MinY>MaxY),
 ,       ,      .
         N.
}

CONST InFileName  = 'GALLERY.PAS';
      OutFileName = '';
      MaxN = 10000;

VAR N: integer;
    P: array[1..MaxN+1] of record x,y:integer; end; {the points}
    MinX,MaxX,MinY,MaxY: integer; {the area for the guard}


Procedure ReadData; { Read the input data - N; P[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    ReadLn(F, P[N].x, P[N].y);
  Close(F);
End;


Procedure Solve; { Find the area in which the guard must be }
  Function Min(a,b:integer): integer;
  Begin if a<b then Min:=a else Min:=b; End;

  Function Max(a,b:integer): integer;
  Begin if a>b then Max:=a else Max:=b; End;

  Procedure CheckLine(x1,y1,x2,y2:integer);
  Begin
    if x1 = x2 then {vertical line}
      if y1 < y2 then {left vertical line}
        MinX:=Max(MinX,x1) {the guard must be on the right from x1}
      else {right vertical line}
        MaxX:=Min(MaxX,x1); {the guard must be on the left from x1}
    if y1 = y2 then {horizontal line}
      if x1 < x2 then {up horizontal line}
        MaxY:=Min(MaxY,y1) {the guard must be on the down from y1}
      else {down vertical line}
        MinY:=Max(MinY,y1); {the guard must be on the up from y1}
  End;

Var i: integer;
Begin
  MinX:=-MaxInt; MaxX:=MaxInt;
  MinY:=-MaxInt; MaxY:=MaxInt; {the guard can be anywhere}
  P[N+1]:=P[1];
  for i:= 1 to N do
    CheckLine(P[i].x,P[i].y, P[i+1].x,P[i+1].y);
End;


Procedure PrintSolution; { Print a position of the guard if any }
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  if (MinX <= MaxX) and (MinY <= MaxY) then
    WriteLn(OutF, MinX,' ',MinY)
  else WriteLn('No solution');
  Close(OutF);
End;


BEGIN
  ReadData;
  Solve;
  PrintSolution;
END.