/*
 '2000 (     .Computer)
  : 
 :           ,   
  .    ,       
    DEL <  >
      ? (    )  * ( 
          )

  :           telnet.
             .  
     -,    ,  
      .    .
    ,  ,   -
     .   (     -
 2-3 )         .     
             20 .
    ,        , 
         100   .    
  ,      .    
   ,           , -
   ,          
  . -     .    -
         ,   -
       ,       .
        .        -
     ,       
 .   ,       DEL <>   -
        ?  *.  -
    (  ),   -  
 0,1,   .  *         -
 .    ,     ,    -
           ,    
  .            -
       DEL.
           .      -
            FILES.TXT.   -
        FILES.TXT,       ,
            .    
    ,        (-
     DEL,     )         HACKER.OUT.
  ,      ,      . -
       !

 :
 FILES.TXT		DELETE.TXT		HACKER.OUT
 PRESLAV		1 3 4 5 6 9		DEL PROST
 PRESLI	  				        DEL ?R?S?A*
 BRESLAV
 BRESLA
 PRESLATA
 PROST
 PARASIT
 PARAVAN
 PRASKAM
 PASCAL
                                   
 :     ,   NP-.  
  ,        ,     -
  .       .
 
 :          ,
    .
                ,  
        .
             (   ) 
   ('?'  '*').        
    .     -     -
  .        ('ABC?????'  'ABC*'.)
       ,    (   -
  ,        .)       
              '?'.  
    ,      '*'.  ,
 .. '*'              -
   (     '*'  '?',    -
      ).  .. ,         
    .
            ,    -
  (,   ,        ,  ),
     ,    ,       .
         ,     
  .
           ,  ..   "-"
 ,   ,            
   - ,..  -      --
  .

           :

 int match( char* mask, char* name ) -     .
  1    0  .
 int files_left( void ) -       . 
 1    0  .
 int count( char* mask ) -     .   ,
      ,  0.
 void put_star( char* mask, int ind ) -  '*'    
 void put_question( char* name, int ind ) -     
 '?'    .
 void generate( char* name, int i ) -     
      .

          ,       
            .
                                                                 
*/
#include <stdio.h>
#include <string.h>

#define MAX_FILES 100
#define FILE_LENGTH 30

char file[][FILE_LENGTH + 1] =
{ "PRESLAV", "PRESLI", "BRESLAV", "BRESLA", "PRESLATA", "PROST", "PARASIT", "PARAVAN", "PRASKAM", "PASCAL" };
char command[MAX_FILES][FILE_LENGTH + 1];
int files = 10;
int need[] = { 1, 0, 1, 1, 1, 1, 0, 0, 1, 0 }; /* files need to be deleted */
int deletes[MAX_FILES]; /* files properly deleted by the best mask of file i */
char del_cmd[MAX_FILES][FILE_LENGTH + 1]; /* command that achieves number in deletes */

int match( char* mask, char* name ) /* compares the mask to the filename */
{
  int i = 0;

  for(; mask[i] == name[i] || mask[i] == '?'; i++ );
  if( i >= strlen( name ) || mask[i] == '*' )
  {
    for(;i < strlen( mask ) ;i++ )
      if( mask[i] != '?' && mask[i] != '*' )
        return 0;
    return 1;
  }
    
  return 0;
}

int files_left( void )
{
  int i;
  int c = 0;

  for( i = 1; i <= files; i++ )
    if( need[i] == 1 ) c++;

  return c;
}

int count( char* mask )
{
  int i, c = 0;

  for( i = 1; i <= files; i++ )
    if( match( mask, file[i] ) )
      if( need[i] == 1 || need[i] == -1 )
        c++;
      else
        return 0;

  return c;
}

void put_star( char* mask, int ind )
{
  int i;
  int del_temp;

  i = strlen( mask );
  mask[++i] = '*', mask[++i] = 0;
  del_temp = count( mask );
  if( del_temp > deletes[ind] )
  {
    deletes[ind] = del_temp;
    strcpy( del_cmd[ind], mask );
  }
  mask[--i] = 0;
  return;
}

void put_question( char* name, int ind ) /* gray algorithm */
{
  int i = 0, p, j, n, del_temp;
  char mask[FILE_LENGTH + 1];

  n = strlen( name );
  strcpy( mask, name );
  do
  {
    p = 0, j = ++i;
    while( !(j % 2) )
      j /= 2, p++;
    if( p < n )
      if( mask[p] == '?' )
        mask[p] = name[p];
      else
        mask[p] = '?';
      del_temp = count( mask );
      if( del_temp > deletes[ind] )
      {
        deletes[ind] = del_temp;
        strcpy( del_cmd[ind], mask );
      }
      put_star( mask, ind );
  }
  while( p < n );

  return;
}

void generate( char* name, int i )
{
  char mask[FILE_LENGTH + 1];

  deletes[i] = 1;
  strcpy( del_cmd[i], name );
  if( strlen( name ) < FILE_LENGTH )
  {
    strcpy( mask, name );
    put_star( mask, i );
  }
  put_question( name, i );

  return;
}

int main( void )
{
  int i, t;

  for(; files_left();)
  {
    memset( deletes, 0, sizeof( int ) * MAX_FILES );

    for( i = 1; i <= files; i++ )
      if( need[i] == 1)
        generate( file[i], i );

    for( i = 2, t = 1; i <= files; i++ )
      if( deletes[t] < deletes[i] ) t = i;
    printf( "DEL %s\n", del_cmd[t] );
    for( i = 1; i <= files; i++ )
      if( match( del_cmd[t], file[i] ) )
        need[i] = -1;
  }

  return 0;
}
