/*
NAME: Ivan Anev
PROG: setfree
LANG: C


       '02 - 16  2002
 11-12  (  )

 3.   

    81 .    4  (A, B, C 
D),          (0,1  2).

   ,       
     .

     :

         A   B   C   D
 1  2   2   1   0
 2  0   2   1   2
 3  1   2   1   1

          :

          A   B   C   D
 1   0   1   0   0
 2   1   0   0   0
 3   1   1   0   1
 4   1   1   1   1
 5   1   2   1   2
 6   2   2   0   2
 7   2   1   1   0

    ,     ?

        SETFREE.TXT   :
          N   
;
   N     ,     
     N- ,    .

  : ,     100*N/Nmax,  Nmax 
  .    3:  


:

       -     20. 
   .      ,    
   .      18  
  ,         .
           .

     .      
      .    .
      (     
        ,   
          ). 
           
   ,           
        .  
     5 .    20.
*/

#include <stdio.h>
#include <string.h>

#define MAXC 81

int cards[MAXC][4];
int best, bc[MAXC];
int current[MAXC];
int v[MAXC];

void init(void);
void solve(void);

int main(void) {
	init();
	solve();

	return 0;
}

void init(void) {
	int i, j, k, l, c;

	c = 0;
	for (i = 0; i < 3; ++i)
		for (j = 0; j < 3; ++j)
			for (k = 0; k < 3; ++k)
				for (l = 0; l < 3; ++l) {
					cards[c][0] = i;
					cards[c][1] = j;
					cards[c][2] = k;
					cards[c++][3] = l;
				}
}

void solve(void) {
	void search(int len, int st);

	current[0] = 0;
	v[0] = 1;
	search(1, 1);
}

void search(int len, int st) {
	int i;
	FILE *fout;

	int canadd(int c, int len);

	if (len > best) {
		best = len;
		for (i = 0; i < best; ++i)
			bc[i] = current[i];

		fout = fopen("setfree.txt", "w");
		for (i = 0; i < len; ++i)
			fprintf(fout, "%d %d %d %d\n", cards[current[i]][0], cards[current[i]][1], cards[current[i]][2], cards[current[i]][3]);
		fclose(fout);
	}

	if (MAXC - st + len > best) {
		for (i = st; i < MAXC; ++i)
			if (v[i] == 0)
				if (canadd(i, len)) {
					current[len] = i;
					v[i] = 1;
					search(len + 1, i + 1);
					v[i] = 0;
				}
	}
}

int canadd(int c, int len) {
	int i, j;

	int isset(int a, int b, int c);

	for (i = 0; i < len; ++i)
		for (j = i+1; j < len; ++j)
			if (isset(current[i], current[j], c))
				return 0;

	return 1;
}

int isset(int a, int b, int c) {
	return ((cards[a][0] + cards[b][0] + cards[c][0]) % 3 == 0 &&
		(cards[a][1] + cards[b][1] + cards[c][1]) % 3 == 0 &&
		(cards[a][2] + cards[b][2] + cards[c][2]) % 3 == 0 &&
		(cards[a][3] + cards[b][3] + cards[c][3]) % 3 == 0);
}
