/*
 B2. 

  SUM.EXE,        N
   ,        
 -    S.

            
 N  S,     (0 < N < 30, S < 100). 

           .



:
1 4 

:
2



   2: 
  

       .  
 F(x,y)  0 <= x < S  0 <= y <= N.  F(x,y)    
  y  ,    x.     
  F(x,N)   x.

         F.    
.        F,   y  ,  
.   F(0,0) = 1  F(x,0) = 0  x < 0.

    .     
  j ( 0 <= j < N),    j+1.      j.
  F(x,j) >= 0   k,   x + k2 < S,    F(x+k*k,j+1)
    F(x,j).

  F(x,y)        y. y = 0   .
    y = 1, 2 ... N.

    F(x,N)     .
*/



/*
NAME: Ivan Anev
PROG: sum
LANG: C++
*/

#include <iostream>
#include <cstring>

using namespace std;

typedef long long lint;

const int maxn = 31;
const int maxs = 100;

class Sum {
private:
	lint f[maxs][maxn];
public:
	void solve() {
		int n, s;
		int i, j, k;
		lint r;

		cin >> n >> s;
		memset(f, 0, sizeof(f));
		f[0][0] = 1;
		for (i = 0; i < n; i++)
			for (j = 0; j < s; j++)
				if (f[j][i])
					for (k = 0; k * k + j < s; k++)
						f[j+k*k][i+1] += f[j][i];

		r = 0;
		for (i = 0; i < s; i++)
			r += f[i][n];

		cout << r << '\n';
	}
};


Sum sum;

int main() {
	sum.solve();

	return 0;
}
