/*
 3. 

  ""    ,      
,             
   .   WORCH.EXE,  
    -  -   - , 
       .

 , .. ,         
 250 000 .           
 .

           
      .




:

ala
bala
crate
racket
tar
tear
labat
 

:

tar
tear
crate
racket



   3: 
  

            ()
          ,  
           
       .

           -
   ,       .     
           ,
               
  -   ,  .   , 
        -.

    ,    ,   
 .         
     .  ,   
          .
         ,  
    .

     A   x, ,     
,       x-1 ,   
   A .   A       , 
      A     , 
          x-1.

 ,          
      .
*/



/*
NAME: Ivan Anev
PROG: worch
LANG: C
*/

#include <stdio.h>
#include <string.h>

#define MAXW 250010
#define MAXLEN 32

int wc;
char words[MAXW][MAXLEN], ori[MAXW][MAXLEN];
int ix[MAXW], sl[MAXLEN];
int back[MAXW], len[MAXW];

void readf(void);
void solve(void);
void writef(void);

int main(void) {
    readf();
    solve();
    writef();

    return 0;
}

void readf(void) {
     char word[MAXLEN];
     int l;

     void sortw(char *word);

     while (scanf("%s", word) != -1) {
           l = strlen(word);
           if (l >= 3) {
              strcpy(ori[wc], word);
              sortw(word);
              strcpy(words[wc++], word);
           }
     }
}

void solve(void) {
     int i, j, l, b, k, p;
     char word[MAXLEN], tmp[MAXLEN];

     int searchw(char *w);
     void sortall(void);

     back[0] = -1;
     for (i = 0; i < wc; ++i) {
         back[i] = -1;
         len[i] = 1;
         ix[i] = i;
     }

     sortall();
     p = 3;
     for (i = 0; i < wc; ++i)
         if ((l = strlen(words[ix[i]])) > p) {
            p = l;
            sl[l] = i;
         }
     sl[p+1] = wc;

     for (k = sl[4]; k < wc; ++k) {
         strcpy (word, words[ix[k]]);
         l = strlen(word);
         for (i = 0; i < l; ++i) {
             for (j = 0; j < i; ++j)
                 tmp[j] = word[j];
             while (word[j])
                   tmp[j++] = word[j+1];
             b = searchw(tmp);
             if (b != -1 && len[b] + 1 > len[k]) {
                len[k] = len[b] + 1;
                back[k] = b;
             }
         }
     }
}

void writef(void) {
     int best, i;
     int stack[MAXLEN], sp;

     best = 0;
     for (i = 1; i < wc; ++i)
         if (len[i] > len[best])
            best = i;

     sp = 0;
     while (best != -1) {
           stack[sp++] = best;
           best = back[best];
     }

     if (strlen(ori[ix[stack[sp-1]]]) == 3) {
        while (sp-- > 0)
              printf("%s\n", ori[ix[stack[sp]]]);
     }
}

void sortw(char *word) {
     int i, j, l;
     char t;

     l = strlen(word);
     for (i = 0; i < l; ++i)
         for (j = i+1; j < l; ++j)
             if (word[i] > word[j]) {
                t = word[i];
                word[i] = word[j];
                word[j] = t;
             }
}

int searchw(char *w) {
    int i, l, down, up, mid, r;

    l = strlen(w);
    down = sl[l];
    up = sl[l+1] - 1;
    while (down <= up) {
          mid = (down + up) / 2;
          r = strcmp(words[ix[mid]], w);
          if (r == 0)
             return mid;
          else if (r > 0)
               up = mid - 1;
          else
              down = mid + 1;
    }

    return -1;
}

void sortall(void) {
     int i, j, g, s, l1, l2, t;

     g = wc;
     do {
        s = 0;
        g = (int)(g / 1.3);
        if (g < 1)
           g = 1;
        if (g == 9 || g == 10)
           g = 11;
        for (j = g; j < wc; ++j) {
            i = j - g;
            if ((l1 = strlen(words[ix[i]])) > (l2 = strlen(words[ix[j]]))
				|| l1 == l2 && strcmp(words[ix[i]], words[ix[j]]) > 0) {
               t = ix[i];
               ix[i] = ix[j];
               ix[j] = t;
               s = 1;
            }
        }
     }
     while (g > 1 || s != 0);
}
