{N;  G[1..N,1..N];  Source Dest
 12
 1 2   4
 1 3   8
 1 6   7
 2 3   4
 2 4   5
 3 4   1
 3 5   7
 4 7   5
 5 7   7
 6 5   2
 6 7   4
 6 10  2
 6 12  5
 7 8   9
 7 9   6
 7 10 12
 8 9   2
 8 11  7
 9 11  8
10 12  8
10 11  3
12 11  1
 0 0  0
 1 11

                            
                         -----------------------

          .  
        .  
     ,   ,      
  ,     .     (u,v)  1 
  - 0  - G[u,v]  .   
 ,  ,          .  
  ,   ,        -
           , -
          . ,  -
               -
 .    ,       -
   ()     ().   -
     ,        
            1 
   ,          1   
    .

    :         (
  )    .   -    
    v  1 .       
    v (   Flow[u,v]  0    (u,v) ).
        .     -
   ,         -
  ,      ,     .
  G[u,v]      (u,v)  0   -
    Flow[u,v]      (u,v)   u  v,
              
 -    G[a,b]-Flow[a,b]   (a,b) 
  .         --
          -  , -
    .     
  ,       .   
      ,     ,  
  :            ,
        .   -
  (v,u)       (u,v).   
        (u,v) - Flow[u,v].   -
      ,         -
  ,      -    -
       ,      0.  
   ,        -
    :         -
 ,       -   -
 :
   - -        
   - -        
    ,         -, -
               -
      ,        -
      .       -
  ,       .   -
       ,      -
 ,         ,     
 ,    ,        -
      .          
 ,      - , 
   .      , 
    -       Ford-Fulkerson 
    -  -  N*N*N.
            
   .        ,-
      -       , 
   ,         .-
         :     
   v      v'. ,   
 v      v'     (v',v)   -
      v.
      ,      .    -
      , ,    
      ,       
   .    :  ,   -
   Source      .   
  A.   B      ,    -
    Dest.      , 
    A     B.
}


CONST MaxN = 100;

VAR G,Flow: array[1..MaxN,1..MaxN] of integer;
    N, Source, Dest: integer;

Procedure ReadData;
Var F: Text;
    v1,v2,Len: integer;
Begin
  Assign(F,'POTOK.PAS'); Reset(F); ReadLn(F);
  FillChar(G,SizeOf(G),0);
  ReadLn(F,N);
  repeat
    ReadLn(F,v1,v2,Len);
    if v1=0 then Break;
    G[v1,v2]:=Len;
  until false;
  ReadLn(F,Source,Dest);
  Close(F);
End;

Procedure FindMinimalFlow;
Var Path: array[1..MaxN] of integer;
    Sign: array[1..MaxN-1] of boolean;
    Poseten:  array[1..MaxN] of boolean;
    Found: boolean;
  Procedure PathFound(Len:integer);
    Function Min(a,b:integer): integer;
    Begin if a < b then Min:=a else Min:=b end;
  Var Value,I: integer;
  Begin
    Value:=MaxInt;
    for I:= 1 to Len-1 do
      if Sign[I] then
        Value:= Min( Value,  G[Path[I],Path[I+1]] - Flow[Path[I],Path[I+1]] )
      else Value:= Min( Value,  Flow[Path[I+1],Path[I]] );
    for I:= 1 to Len-1 do
      if Sign[I] then
        Inc( Flow[Path[I],Path[I+1]], Value )
      else Dec( Flow[Path[I+1],Path[I]], Value );
    Found:=true;
  End;
  Procedure FindPath(v,Br:integer);
  Var Next: integer;
  Begin
    if Found or Poseten[v] then Exit;
    Path[Br]:=v; Poseten[v]:=true;
    if v = Dest then PathFound(Br);

    for Next:= 1 to N do
      if G[v,Next] > Flow[v,Next] then
        begin Sign[Br]:=true; FindPath(Next,Br+1); end;

    for Next:= 1 to N do
      if Flow[Next,v] > 0 then
        begin Sign[Br]:=false; FindPath(Next,Br+1); end;
  End;
Var I,J, MaxFlow: integer;
Begin
  FillChar(Flow,SizeOf(Flow),0);
  repeat
    Found:=false;
    FillChar(Poseten,SizeOf(Poseten),false);
    FindPath(Source,1);
  until not Found;

  MaxFlow:=0;
  for I:= 1 to N do
    Inc(MaxFlow,Flow[Source,I]);
  WriteLn('Maximal flow = ',MaxFlow);
  for I:= 1 to N do
    for J:= 1 to N do
      if Flow[I,J] > 0 then
        WriteLn('(',I,',',J,') = ',Flow[I,J]);
End;

BEGIN
  ReadData;
  FindMinimalFlow;
END.