/*
 '2000
  E:  
 :           
  (<= 1000000),   ,     <= 1000 ( 
      1500).
 
  :         
   ,    .      
          ,      , 
     -   .  
             -
     . ,     -
    ,    ,  -   
 :  ,        ,  
       ,  .       
    ,    .       -
 ?    ,      
                
   .
                   TEXT.EXE,
          .     
   TEXT.INP,            
 ,      ,      .  
   -  20 .       TEXT.OUT -
      .

 
 TEXT.INP
           
          
      

 TEXT.OUT
 

 :
         ,           .
    :        
         .  ..    
      (   - 1000   -
  ,      .)        
    .      ,
    .
           .          
      ,    ,   -
         1.     --
 ,       ,  .

 :
      -,       (..  ).
         ,    -
        .
       (          )
*/

#include <stdio.h>
#include <string.h>

typedef struct { char name[21]; long int count; } t_word;

#define MAX 1000

t_word words[MAX];
int word_cnt = 0;

void insert_word( char * word )
{
   int l = 0, r = word_cnt;
   int x = 0;
   int i;
   int comp;

   if ( word_cnt == 0 )
   {
      word_cnt++;
      strcpy( words[0].name, word );
      words[0].count = 1;
      return;
   }

   comp = strcmp( word, words[0].name );
   if ( comp < 0 )
   {
      for ( i = word_cnt; i > 0; i-- )
      {
         words[i+1].count = words[i].count;
         strcpy( words[i+1].name, words[i].name );
      }

      word_cnt++;
      strcpy( words[0].name, word );
      words[0].count = 1;

      return;
   }
   else
   if ( comp == 0 )
   {
      words[0].count++;
      return;
   }

   for (;;)
   {
      x = (l + r) / 2;
      comp = strcmp( word, words[x].name );

      if ( comp < 0 )
      {
         r = x;
      }
      else
      if ( comp == 0 )
      {
         words[x].count++; return;
      }
      else
      {
         l = x;
      }

      if ( l == r ) break;
      if ( l + 1 == r ) break;
   }

   for ( i = word_cnt; i > l; i-- )
   {
      words[i+1].count = words[i].count;
      strcpy( words[i+1].name, words[i].name );
   }

   word_cnt++;
   strcpy( words[l+1].name, word );
   words[l+1].count = 1;
}

int main( void )
{
   char word[21];
   long int i, word_count, half_count, br;

   freopen( "text.c", "r", stdin );

   word_count = 0;
   while ( scanf( "%s", word ) != EOF && word_count < MAX)
   {
      insert_word( word );
      word_count++;
   }

   half_count = ( word_count / 2 ) + ( word_count % 2 );
   br = 0;
   i = 0;

   for (;;)
   {
      br += words[i].count;
      if ( br >= half_count ) break;
      i++;
   }

   printf( "%s", words[i].name );

   return 0;
}