{
                            
                          -------------------

    (        )
                             (, 1999)


     Kompania proizvezhda trubi s ednakuv diametur. Vsichki trubi se suhra-
 niavat v pravougulni konteineri, no konteinerite se poluchavat v niakolko
 razlichni razmera. Trubite se suhraniavat po redove v konteinerite, taka
 che v redovete da niama prazno miasto (mozhe da ima samo malko prostranstvo
 v kraia na reda). V naprechnoto sechenie trubite se suhraniavat ili v
 mrezhov format (grid), ili vuv verefen (skew). Eto i primeri:

   O O        O O O          O O O         O O O O
   O O        O O O         O O O O         O O O O
   O O        O O O          O O O         O O O O
   grid       grid          O O O O         O O O O
                              skew           skew

 Oburnete vnimanie, che vupreki che ne se vizhda ot diagramata, niama miasto
 mezhdu trubite vuv vseki red, t.e. te sa naredeni plytno edna do druga. Wse
 pak prazno mqsto move da ima, no to e samo w kraishtata. Wavnoe da se widi,
 she w zadachata ne se tyrsi optimalno napylwane na konteiner, a samo takowa
 napylwane, pri koeto wseki dwe sysedni trybi se dopirat, koeto ne e winagi
 optimalno w obshtiq sluchaj.

    Vhod:
 Vhodut e posledovatelnost ot razmerite na naprechnite sechenia na konteine-
 rite. Vsiako naprechno sechenie e dadeno s dve realni stoinosti otdeleni s
 interwal. Razmerite sa izrazeni chrez diametrite na trubite kato edinica
 miarka, t.e. movete da priemete che wsqka tryba ima diametyr 1. Zabelezhete
 che naprechnoto sechenie s razmeri a x b e sushtoto kato b x a.

   Izhod:
 Za vsiako vhodno naprechno sechenie vashata programa triabva da izvezhda
 maksimalnia broi truvi, koito mogat da se paketirat v tova naprechno
 sechenie. Broiat na trubite e cialo chislo, sled koeto se izvezhda dumata
 grid, ako e rezultat ot mrezhova forma i skew, ako e rezultat ot verefna
 forma. Ako i pri dvete formi se poluchava ednakuv rezultat, to se izvezhda
 grid.

   Primer:
 Vhod:      Izhod:
 3 3        9 grid
 2.9 1      29 skew

 ---------------------------------------------------------------------------
     Reshenie:
 Zadachata e dosta matematicheska, zatova smiatam, che reshenieto niama
 nuzhda ot mnogo komentar. Tova, koeto prilozhenata programa pravi, e da
 poluchi rezultata ot narezhdane po grid, sled tova po skew (shirochina a,
 visochina b) i skew (shirochina b, visochina a), sled koeto da sravni
 trite rezultata i da izkara nai-golemia ot tqh.
}

var w,h:real;

procedure GetData; { Read the input data - the sizes of the  }
begin
  writeln;
  write('Dimensions: ');
  readln(w,h);
end;

function GetGrid(x,y:real):longint;
begin { Return the maximal pipes in container x * y arranged compact as grid }
  GetGrid:=trunc(x)*trunc(y);
end;

function GetSkew(x,y:real):longint;
 { Return the maximal pipes in container x * y arranged compact as skew }
var n,n2,ny:longint;
    nyr:real;
    r:longint;
begin
  n:=trunc(x);
  if (x-trunc(x))>0.5 then n2:=n else n2:=n-1;

  if (n=0) or (n2=0) then
    begin GetSkew:=0; exit; end;

  nyr:=2.0*(y-1.0);
  nyr:=nyr/sqrt(3);
  nyr:=nyr+1;
  ny:=trunc(nyr);

  r:=((ny div 2)+(ny mod 2))*n + (ny div 2)*n2;
  GetSkew:=r;
end;

procedure Solve; { Find and print the maximal number number of pipes }
var gr,sk1,sk2,fin:longint;
begin
  gr:=GetGrid(w,h);
  sk1:=GetSkew(w,h);
  sk2:=GetSkew(h,w);

  if (gr>=sk1) and (gr>=sk2) then
    writeln(gr,' grid')
  else if (sk1>=sk2) then
    writeln(sk1,' skew')
  else writeln(sk2,' skew');
end;


{-----------------------------   ----------------------------}
begin
  while true do
  begin
    GetData;
    Solve;
  end;
end.
