{ This is teh input data:  N;  (N intervals);  M;  (M intervals);
 2
 1 5
 12 20
 4
 2 10
 6 11
 15 25
 26 30

                             
                            ----------------

             1     -
 ""  "".       1  365   -
        .     , -
      -   "",  
 "",     ..   N   "-
 "  M   ""        -
   ,     .    -
   .           . -
    N (N<500), N-   "" (    ),  M
 (M<500)  M-   "".      
      ,      ""    
 "".
                                
                                -------

           .  Blue[d]  -
         1  d    
           [1..d]  
 "" .    Red[d]      
      1   d,       
   "".    ,    -
      Max( Blue[365], Red[365] ),    Blue()  Red()
       :
     Blue[0] = 0
     Blue[d] = Max ( Blue[d-1],          d > 0
                     Red[b-1] + d-b+1     ""  (b,d)  )
     Red[0] = 0
     Red[d] = Max ( Red[d-1],            d > 0
                    Blue[b-1] + d-b+1     ""  (b,d)  )
   ,     d    
      ;      
  "",     d,      
              
 "";        "", 
    d,          -
            "".    -
     ,   .     
 ,     -      
       .      -
   (    ),       -
 ,             -
     .   Blue()  Red()   
  Day  ,      Day  , ,
   -   Day,     .
             
         ,  -
    .      365      -
    ,         -
          .   -
       N*N/2 + M*M/2,    -
   ,          -
     .       
   .     365  (   
 )            
   .          
 ,           -
  . ,  ,    .
}

CONST InFileName  = 'ZALA.PAS';
      OutFileName = '';
      MaxN        = 5000;
      MaxD        = 365;

TYPE Tzaqvka = record b,e:integer; end;
     TzaqvkiList = array[1..MaxN] of Tzaqvka;

VAR N,M: integer;
    BlueZaqvki,RedZaqvki: TzaqvkiList;
    Blue,Red: array[0..MaxD] of
                record Total,BrBlue,BrRed:integer; end;


Procedure ReadData; {  : N,BlueZaqwki[1..N], M,RedZaqwki[1..M] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    with BlueZaqvki[N] do
      ReadLn(F,b,e);
  ReadLn(F,M);
  for M:= 1 to M do
    with RedZaqvki[M] do
      ReadLn(F,b,e);
  Close(F);
End;


Procedure Sort(var Z:TzaqvkiList; Count:integer); {   }
Var i,j: integer;
    swp: Tzaqvka;
Begin
  for i:= 1 to Count do
    for j:= i+1 to Count do
      if Z[i].e > Z[j].e then
        begin swp:=Z[i]; Z[i]:=Z[j]; Z[j]:=swp; end;
End;


Procedure SolveDynamic; {      }
Var Day, BlueIndex, RedIndex: integer;
Begin
  with Blue[0] do
    begin BrBlue:=0; BrRed:=0; Total:=0; end;
  with Red[0] do
    begin BrBlue:=0; BrRed:=0; Total:=0; end;
  BlueIndex:=1;
  RedIndex:=1;
  { Calculate Blue[1..MaxD], Red[1..MaxD] }
  for Day:= 1 to MaxD do
    begin
      { Calculate Blue[Day] }
      Blue[Day]:=Blue[Day-1];
      for BlueIndex:= 1 to N do
        with BlueZaqvki[BlueIndex] do
	  if e > Day then Break
          else with Blue[Day] do
            if Red[b-1].Total + (e-b+1) > Total then
              begin
                Total:=  Red[b-1].Total + (e-b+1);
                BrBlue:= Red[b-1].BrBlue + (e-b+1);
                BrRed:=  Red[b-1].BrRed + 0;
              end;
      { Calculate Red[Day] }
      Red[Day]:=Red[Day-1];
      for RedIndex:= 1 to M do
        with RedZaqvki[RedIndex] do
	  if e > Day then Break
          else with Red[Day] do
            if Blue[b-1].Total + (e-b+1) > Total then
              begin
                Total:=  Blue[b-1].Total + (e-b+1);
                BrBlue:= Blue[b-1].BrBlue;
                BrRed:=  Blue[b-1].BrRed + (e-b+1);
              end;
    end;
End;


Procedure PrintResult; {      }
Const CRLF = #10#13;
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  if Blue[MaxD].Total > Red[MaxD].Total then
    with Blue[MaxD] do
      WriteLn(OutF, Total, CRLF, BrBlue, CRLF, BrRed )
    else with Red[MaxD] do
      WriteLn(OutF, Total, CRLF, BrBlue, CRLF, BrRed );
  Close(OutF);
End;


BEGIN
  ReadData;
  Sort(BlueZaqvki,N); Sort(RedZaqvki,M);
  SolveDynamic;
  PrintResult;
END.