{
     , 24  2001

 2 ( 11-12 )   (Build)

        , 
   .      ( 
    ),       
12,            , 
         .

  ,    BUILD.EXE,   
     ,   
   W  H (2 <= W, H <= 11),  ,  
          .

:   BUILD.INP       W  H 
  .

:   BUILD.OUT     
  W  H  .

:
BUILD.INP          BUILD.OUT
2 4                5
2 3                3
1 3                0
2 11               144
2 2                2


:

        :  
 ,            
.            .
  ,    N   M ,  N >= M.

   N  M    ..  N*M   
     ,       0   
          (   2
).  ,         
   .

      ,    
      .     ,  
          
  .       -
,          
(  -     32- ).

     ,     
          ..
    /       
            .
          
 .  ,         
    !? ,     .

  ,         
.     i  ,    
   (   )    1  i-1,
        i    
        i+1  N.     i
  e   1,      0.
      M  (  M ).  
       k,    
   .    A[i,k]   
     i,  k    
    i.   , A[N,0]   
     N  .      
  A.

  A[0,0] = 1,  A[0,k] = 0   k   0.  
    A[i,k]    k.  
   i     (i,j).  
(i,j)   :
   x)    
   y)       ( .)  (i,j+1)
   z)        - (i-1,j).

  x)  z)  ,      
(i,j+1),    y)    (i,j+2). 
 x)  y)  (i-1,j)      
   i-1 (        i), a
  z)  (i-1,j)      
   i-1.

   (i,j)      
 j.       (i,j),   j > M,
        i    
    i.  CurrentRow    
      i,  PreviousRow  
        i-1. 
 A[i,CurrentRow]  A[i-1,PreviousRow].

,     i      
 - (i,1). ,        
  A.

 -    .     
 .         
,       O(N*3^M),  N>=M.


--Kristiyan Haralambiev
}
program build;
const
        InFile                          = 'build.inp';
        OutFile                         = 'build.out';
        Max                             = 12;
type
        Int64                           = Comp;
var
        A                               : array[0..Max, 0..1 shl Max - 1] of Int64;
        Bit                             : array[1..Max] of Integer;
        Ans                             : Int64;
        N, M                            : Integer;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
        Fi                              : Text;
        Tmp                             : Integer;
begin
{read}
  Assign(Fi, InFile); ReSet(Fi);
  ReadLn(Fi, N, M);
  Close(Fi);

{normalize, so that recursion has small depth}
  if N < M then begin
    Tmp := N;
    N := M;
    M := Tmp;
  end;

{set Bit masks}
  for Tmp := 1 to Max do Bit[Tmp] := 1 shl (Tmp-1);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
        I, CurRow, PrevRow              : Integer;

   procedure Compute(J : Integer);
 {case 0: recursion STOP}
   begin
     if J > M then begin
       A[I,CurRow] := A[I,CurRow] + A[I-1,PrevRow];
       Exit;
     end;

     {case x:}
     Inc(CurRow, Bit[J]); { (I,J) - empty }
     Compute(J+1);


     {case z: (I,J)<->(I-1,J) is a pair}
     Dec(CurRow, Bit[J]);  { (I,J) - filled }
     Inc(PrevRow, Bit[J]); { (I-1,J) - empty, at the previous stage}
     Compute(J+1);

     {case y: (I,J)<->(I,J+1) is a pair}
     Dec(PrevRow, Bit[J]);  {(I-1,J) - filled, at the previous stage}
     if J < M then Compute(J+2); 
   end;

begin
  FillChar(A, SizeOf(A), 0);
  A[0,0] := 1;
  CurRow := 0;
  PrevRow := 0;

  for I := 1 to N do Compute(1);

  Ans := A[N,0];
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
        Fo                              : Text;
begin
  Assign(Fo, OutFile); ReWrite(Fo);
  WriteLn(Fo, Ans:0:0);
  Close(Fo);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.

