{
8 10
4 8 8 6
3 6 3 8
1 6 3 6
1 1 0 3
3 6 4 6
8 4 8 6
2 4 0 3
2 4 6 3
4 1 4 6
3 2 2 4
                               
                              -------------

            N x N  (N<=20),  
       1 x 1.     -
  ,          .
   M-      ,  
   ,          .     -
      .        
      ,       
    .    ,   -
        .    -
 :    - N  M;   M  - M   x1,y1, x2,y2
  x1,y1,x2,y2  [0..N].

      :        -
  -   .        
  0  20  X   Y.       21*21 -
 .          ,    
     .    
      :     
  ,          ,
           . 
        / /.   
 ,           , -
   -   21*21    21*21*(21*21+1)/2  -
   21*21/2 .  ,    
  21*21/2-1    -   21*21*(21*21+1)/2 ,
          N^6      
    N.     - .
         ,      
    ,   -, ..     
        ,     -
     .  K-1 (K     ) -
             .
        /  -
    /.     (  )  
  1             -
  .      ,   -
    1.            
   N*N,        -
 .    (     1    
   -    1)   -
     1 .      N*N/2,
            N*N*N*N, -
    .       
   .   -     -
    :         
    1 (     ).   -
         ,   -
          .    -
    ,     ,    
        .    ,  
 ,   ""  .     ,
    1  ,       -
       1.        
   .      ,  -
             -
  1.            
   .    ,      
   G[0..N,0..N],          (-
     ),       -
       ,    ( -
  AddRebro).        N = 50  M = 5000.
}

{$R-,S-,Q-}
{$M 65520,0,655360}

CONST InFileName  = 'CABLESET.PAS';
      OutFileName = '';
      MaxN = 50;
      MaxV = (MaxN+1)*(MaxN+1);

TYPE TPoint = record x,y: byte; end;
     TNasl = array[1..MaxV] of TPoint;
     PNasl = ^TNasl;

VAR N: integer;
    G: array[0..MaxN,0..MaxN] of record
                                   Color: integer;
                                   BrNasl: integer;
		                   Nasl: PNasl;
                                 end;
    BrComponents: integer;
    Comp1X,Comp1Y: integer;
    TotalLen: integer;
    OutF: Text;


Procedure AddRebro(x1,y1,x2,y2:integer);
Var Temp: PNasl;
Begin
  with G[x1,y1] do
    begin
      Inc(BrNasl);
      GetMem(Temp,BrNasl*SizeOf(TPoint));
      Move(Nasl^,Temp^,(BrNasl-1)*SizeOf(TPoint));
      Temp^[BrNasl].x:=x2; Temp^[BrNasl].y:=y2;
      FreeMem(Nasl,BrNasl-1); Nasl:=Temp;
    end;
End;


Procedure ReadData; {      G[1..N,1..N]}
Var F: Text;
    i,j,x1,y1,x2,y2,M: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N,M);
  FillChar(G,SizeOf(G),false);
  for M:= 1 to M do
    begin
      ReadLn(F, x1,y1,x2,y2);
      AddRebro(x1,y1,x2,y2);
      AddRebro(x2,y2,x1,y1);
    end;
  Close(F);
End;


Procedure ColorComp(x,y,NewColor:integer);
Var i: integer; { ,     (x,y)   NewColor}
Begin
  with G[x,y] do
    if Color <> NewColor then {if not colored yet}
      begin
        Color:=NewColor;
        for i:= 1 to BrNasl do
          with Nasl^[i] do
            ColorComp(x,y,NewColor);
      end;
End;


Procedure ColorComponents; {     }
Var x,y: integer;
Begin
  BrComponents:=0;
  for x:= 0 to N do
    for y:= 0 to N do
      if (G[x,y].Color = 0) and (G[x,y].BrNasl<>0) then
        begin
	  Inc(BrComponents); ColorComp(x,y,BrComponents);
          if BrComponents = 1 then
	    begin Comp1X:=x; Comp1Y:=y; end;
	end;
End;


Procedure ConnectComponent_1; {  1  -  }
Var SS: array[1..MaxV] of record
                            x,y:byte;
                            prev: integer;
                          end;
    Poseten: array[0..MaxN,0..MaxN] of boolean;
    Cur,CurX,CurY,SP: integer;
    Merged: boolean;

  Procedure AddPoint(x,y,prev:integer);
    Procedure MergeComp;
    Var Len,BegX,BegY: integer;
    Begin {merge the components 1 and G[x,y]^.Color}
      Len:=0;
      repeat
        Inc(Len);
        BegX:=SS[prev].x;
        BegY:=SS[prev].y;
        prev:=SS[prev].prev;
      until prev = 0;
      AddRebro(x,y, BegX,BegY);
      AddRebro(BegX,BegY, x,y);
      Inc(TotalLen,Len);
      ColorComp(x,y,1);
      Dec(BrComponents);
      Merged:=true;
      {WriteLn(OutF,'(',BegX,',',BegY,') - (',x,',',y,'), len = ',Len);}
    End;
  Begin
    if (x < 0) or (x > N) or (y < 0) or (y > N) or Poseten[x,y] then Exit
    else Poseten[x,y]:=true;
    inc(SP); SS[SP].x:=x; SS[SP].y:=y; SS[SP].prev:=prev;
    if G[x,y].Color > 1 then
      MergeComp;
  End;

  Procedure QueueComponent(x,y:integer);
  Var i: integer;
  Begin
    with G[x,y] do
      if Color = 1 then {if the vertex is from component 1}
        begin
          AddPoint(x,y,0);
          for i:= 1 to BrNasl do
            with Nasl^[i] do
              if not Poseten[x,y] then
                QueueComponent(x,y);
        end;
  End;

Begin
  FillChar(Poseten,SizeOf(Poseten),false);
  SP:=0; QueueComponent(Comp1X,Comp1Y); {    1}
  Cur:=1; Merged:=false;
  repeat { }
    CurX:= SS[Cur].x;
    CurY:= SS[Cur].y;
    AddPoint(CurX+1,CurY,Cur);
    AddPoint(CurX-1,CurY,Cur);
    AddPoint(CurX,CurY+1,Cur);
    AddPoint(CurX,CurY-1,Cur);
    Inc(Cur);
  until (Cur > SP) or Merged;
End;


BEGIN
  ReadData;
  ColorComponents;
  Assign(OutF,OutFileName); Rewrite(OutF);
  TotalLen:=0;
  while BrComponents > 1 do
    ConnectComponent_1;
  WriteLn(OutF,TotalLen);
  Close(OutF);
END.
