{
    , 8-10  2002

 2 ( 11-12 )   (Comp)

    N    (1 < N < 300), 
  .       
:            
K  (0 < K < N),        
 .   -   ,
     ,       
       ,    -
,   -.   COMP.EXE ,  
           
.

       COMP.INP.     
  N  K,    .    , 
         .

          COMP.OUT,
     .        
      -    
  .          K
 ,     .       
   ,      ,  
    ,      
 ..

:

COMP.INP
9 3
0 0 0 0 0 6 7 8 9

COMP.OUT
3
6 1 2


:

          , 
      ,      . 
 i-    B[i].   N  , 
    M  (     
) ,  -         
.       .

   A   MxN,  A[i,j]    
     j   N     
  i .   i<=j. 

      A[i,j] = min( max(a[i-1,L-1], sum(L,j)) ), 

  * sum(L,j) = B[L] + B[L+1] + . . . + B[J]
  * L   -   i- a
  * L     i  j.

    A[i,j]    a[i-1,L-1]   i, j
 L (i<=L<=j).  ,     ,  
 [M,N].  ,     sum(L,j)  
 (        
),       O(M*N^2).    
,       .

     ,     a  (i,j)
 L(i,j)    L,      
[i,j].

 1)  L(i,j+1) >= L(i,j)        
 .  ,    A[i,j+1]   
L   L(i,j)     .
     L,    L`, e :
     [i-1,L-1] > sum(L,j+1),
   L > L`
  A[i-1,L-1] >= A[i-1,L-1] > sum(L,j+1) >= sum(L,j+1).
     L -  L    
-   A[i,j]   .

 2)    i  j, L e  :
   * A[i-1,L-1] <= sum(L,j)
   * A[i-1,L] > sum(L+1,j)
 L(i,j) = L  L+1 ..
[i,j] = min( max(A[i-1,L-1], sum(L,j),
              max(a[i-1,L], sum(L+1,j) )
(:   -      max 
 ,       max 
.)
  1)     L>L`     -
  A[i,j].    L<L-1   ,  Sum(L,j)
<= Sum(L,j) ..       -   A[i,j].

  -  (   ), 
 i    O(N)   A[i,j]   j:
* j<i, [i,j]   .
*A[i,i] = min( A[i-1,j-1], B[i]).
* N>j>=i, L     L (L     2) 
i  j)     A[i,j+1]   1.

     O(M*N),    -.
       .

 Ahlp    L(i,j).   
   -    .  
    ,   ,    
  .  ,      ( )  K
( ).


--Kristiyan Haralambiev
}
program comp;
const
        InFile                          = 'comp.inp';
        OutFile                         = 'comp.out';
        MaxN                            = 300;

var
        A                               : array[1..MaxN,1..MaxN] of Integer;
        Ahlp                            : array[1..MaxN,1..MaxN] of Integer;
        B                               : array[1..MaxN] of Integer;
        N, M                            : Integer;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
function GiveOnes(I : Integer) : Integer;
var
        J                               : Integer;
begin
  J := 0;
  while I <> 0 do begin
    Inc(J);
    I := I and (I-1);
  end;
  GiveOnes := J;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure InPut;
var
        Fi                              : Text;
        I, J                            : Integer;
begin
  Assign(Fi, InFile); ReSet(Fi);
  ReadLn(Fi, N, M);
  for I := 1 to N do begin
    Read(Fi, J);
    B[N+1-I] := GiveOnes(J);
  end;
  Close(Fi);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
function Max(X, Y : Integer) : Integer;
begin
  if X > Y then Max := X else Max := Y;
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure Go;
var
        I, J, K, L                      : Integer;
{---------------------}
    procedure TryUpdate;
    begin
      if  Max(A[I-1,L-1], K) < A[I,J] then begin
        A[I,J] := Max(A[I-1,L-1], K);
        Ahlp[I,J] := L;
      end;
    end;
{---------------------}
begin
  FillChar(A, SizeOf(A), $3F);

  {pyrvi red na A}
  A[1,1] := B[1]; for J := 2 to N do A[1,J] := A[1,J-1] + B[J];
  for J := 1 to N do Ahlp[1,J] := 1;

  for I := 2 to M do begin
    L := I;
    K := B[I]; {suma na i-ta grupa}
    A[I,I] := Max(A[I-1,L-1], K);
    Ahlp[I,I] := L;
    for J := I+1 to N do begin
      {dobavqme stoinostta na sledvashtoto chislo}
      Inc(K, B[J]);

      {mestim L spazvaik trik 1}
      repeat
        TryUpdate;
        Dec(K,B[L]);
        Inc(L);
      until (A[I-1,L-1] > K) or (L = J);

      {probvame da podobrim stoinostta na A[I,J]}
      TryUpdate;

      {vryshtame L s edna poziciq nazad, za da e vqrno, che L = L'}
      if (A[I-1,L-1] > K) and (L > I) then begin
        Dec(L);
        Inc(K,B[L]);
      end;
    end; { for j}
  end; { for i}
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
procedure OutPut;
var
        Fo                              : Text;
        I, J, L                         : Integer;
begin
  Assign(Fo, OutFile); ReWrite(Fo);
  WriteLn(Fo, A[M,N]);

  L := N+1;
  J := N;
  I := M;
  repeat
    Write(Fo, L-Ahlp[I,J], ' ');
    L := Ahlp[I,J];
    J := L-1;
    Dec(I);
  until  I = 0;
  Close(Fo);
end;

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}
begin
  InPut;
  Go;
  OutPut;
end.
