{ This is the input data:
   1 1 1
 0 1 0 0 1
 0 1 0 0 1
 0 0 1 1 1
   0 0 0

                      -----------------------
                         21 
                      -----------------------

      :
                 X X X
               X X X X X
               X X X X X
               X X X X X
                 X X X
   (    "X")     0  1.  -
     3    -   9  -
      3x3;     5   
   ;     .   -
      : 0  1,  1  0.    -
 ,      (  21 )  -
     3-  ,    ,  -
   0      .     -1   -
 .    :
      0 0 0                0 0 0                1 0 0
    0 0 0 0 0   . 1    0 0 1 1 1   . 2    1 1 0 1 1
    0 0 0 0 0  ------->  0 0 1 1 1  ------->  0 1 1 1 1
    0 0 0 0 0            0 0 1 1 1            0 0 1 1 1
      0 0 0                0 0 0                0 0 0
     (. 1)             (. 2)             (. 3)
      . 3,        (.1)
  2 ,     .

 :              
           .  -
    : 1       5 -
 ,  2 -   9 ,   3 -   1 .
             -
 ,       5+9+1 = 15   :
         .    
   1,2,..,15.     ,    
          -
   15-  [1,2,...15].       
 N-   2^N.         -
    32768 (2^15),        .
           32768    
         .    ,-
  .     1,     ,   -
     .
             , 
       21 , 15-    
  21  -    ,     -
  .   15-   
   -  1   0  2^15-1.     
           -
       .   k-   
  1,     k- ,    0, k-  
  .      ,    -
           
      .
            ,   - 
    .     .  -
    21 ,      0  1,   -
        2^21.      P, -
          . 
        256 KB   ( 1   -
  ).     .
     P[0] = 1; P[1..2^21-1] = 0;
     for turn = 1 to endlessness
        NewObtained = false
        for i = 0 to 2^21-1
           if P[i] then
              T = NumberToBoard(i);
              for op = 1 to 15
                 NewT = MakeOperation(op,T);
                 if NewT = DestinationBoard
                    PrintSolution(turn); Exit;
                 if P[ BoardToNumber(NewT) ] = 0 then
                    P[ BoardToNumber(NewT) ] = 1
                    NewObtained = true
        if NewObtained = false then
          NoSolution
         0  2^21-1,  
 ,   0    0 .    
    ,        1  
      P.        -
    ,        
   P.    P  ,   
   0, 1  2 .      -
 ,     0, 1, 2  3   ..   
  ,         ,  -
    .       ,  -
  .
                                                               16.03.2000
                                                             
                                                       (  )

}

{$R-,S-,Q-}
CONST InFileName  = 'GAME21.PAS';
      OutFileName = '';

Type TGame = array[1..21] of byte;

VAR Dest: TGame;


Procedure ReadData; { Read the input data - Dest }
Var F:Text;
    i: integer;
    ch: char;
Begin
  Assign(F,InFileName); Reset(F);
  for i:= 1 to 21 do
    begin
      Read(F,ch); while (ch <>'0') and (ch<>'1') do Read(F,ch);
      if ch='0' then Dest[i]:=0 else Dest[i]:=1;
    end;
  Close(F);
End;


Function Correct(bitmask:longint): boolean;
{ This apply the operations given in the bitmask upon the 0-filled board
  and returns if the obtained board is the board we are looking for /Dest/ }
Const Operation: array[1..15] of TGame =
(
 { squares shapes}
  (1,1,1,0,1,1,1,0,0,1,1,1,0,0,0,0,0,0,0,0,0), {1,2,3,5,6,7,10,11,12}
  (0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,1,0,0,0,0,0), {4,5,6,9,10,11,14,15,16}
  (0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,1,0,0,0,0), {5,6,7,10,11,12,15,16,17}
  (0,0,0,0,0,1,1,1,0,0,1,1,1,0,0,1,1,1,0,0,0), {6,7,8,11,12,13,16,17,18}
  (0,0,0,0,0,0,0,0,0,1,1,1,0,0,1,1,1,0,1,1,1), {10,11,12,15,16,17,19,20,21}
 { chryst shapes}
  (1,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0), {1,4,5,6,10}
  (0,1,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0), {2,5,6,7,11}
  (0,0,1,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0), {3,6,7,8,12}
  (0,0,0,0,1,0,0,0,1,1,1,0,0,0,1,0,0,0,0,0,0), {5,9,10,11,15}
  (0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,1,0,0,0,0,0), {6,10,11,12,16}
  (0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,0,1,0,0,0,0), {7,11,12,13,17}
  (0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,0,0), {10,14,15,16,19}
  (0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1,0), {11,15,16,17,20}
  (0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,1,1,0,0,1), {12,16,17,18,21}
 { whole the space shape}
  (1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1)  {1,2,....,20,21}
);
Var T: TGame;
    i,op: integer;
Begin
  for i:= 1 to 21 do T[i]:=0;
  for op:= 1 to 15 do
    if bitmask and (1 shl (op-1)) <> 0 then
      for i:= 1 to 21 do {apply operation op}
        T[i]:=T[i] xor Operation[op][i];
  for i:= 1 to 21 do
    if T[i] <> Dest[i] then
      begin Correct:=false; Exit; end;
  Correct:=true;
End;


Function CountOfBits(bitmask:longint): integer;
{ Return the count of bits 1 in the binary represantation of bitmask }
Var bits: integer;
Begin
  bits:=0;
  repeat
    if odd(bitmask) then inc(bits);
    bitmask:= bitmask div 2;
  until bitmask = 0;
  CountOfBits:= bits;
End;


Procedure Solve;
Var OutF: Text;
    Best: integer;
    i: longint;
Begin
  { Find the solution. There are only 32768 configurations to check }
  Best:=MaxInt;
  for i:= 0 to (1 shl 15)-1 do
    if Correct(i) then
      if CountOfBits(i) < Best then
        Best:=CountOfBits(i);
  { Print the found solution }
  Assign(OutF,OutFileName); Rewrite(OutF);
  if Best <> MaxInt then WriteLn(OutF,Best)
  else WriteLn(OutF,-1);
  Close(OutF);
End;


BEGIN
  ReadData;
  Solve;
END.
