{   :
3 2 4
1 1
2 1
3 1
3 2

XVII    

  -  1. 

           
       M   
  N     (M  N   1000, 
      1,2,...,M    
1,2,...,N   ).      
K       ,     
.    ,      
     .       
  :        
     ,         
      ,     
 .        
    - ,     
             
 .
  CONF.EXE,    M, N, K   
K  ,       
           
.
  CONF.INP       M, N  K, 
    .    K    
       P1-P2,  P1  
  ,  P2      P1  P2  
   .
  CONF.OUT         
   .

:

          minimum edge cover.
Minimum edge cover        
     .      
 ,      (matching)   .
             
     ,       
  (  ).     
      ,    
  ,           -
   ,          
  .

               
  :
matched + (n + m - 2 * matched)
 matched      .
n + m - 2 * matched
   ,    .

          
   ,       
.

        ,   
      .   .  
         .

          -
        ,   
   ,    BFS.

       
--   ADJ[i]     #i
--      #i     ADJT[i].
-- G[i, j]  TRUE       (i,j).

    ,      
"residual"   Ford-Fulkerson,       
    > 1   G[i, j]      
( flow units)  (i,j),     P  (i,j)   
   (i,j) .. G[i, j] := G[i, j] - P    
  (j,i) .. G[j, i] := G[j, i] + P.   
            
  > 0,         .
    ,        -
      dijkstra.    
   -  ,   
    .

   0-1 ..    0  1.    , 
             unit 
(i,j)   boolean,   G[i, j].   0-1   
          .

     :
--   #i   M     i.
--   #i   N     i + |M|
   (|M|=    M).
-- ()  |M|+|N|+1
-- ()  |M|+|N|+2

Jivko Ganev
}

const
  infile = 'conf.pas';
  outfile = 'conf.out';
  maxm = 1100;
  maxn = 1100;

var
  G : array [1..maxm + maxn + 2, 1..maxm + maxn + 2] of boolean;
  ADJ : array [1..maxm + maxn + 2, 1..maxm + maxn + 2] of integer;
  {  }
  ADJT : array [1..maxm + maxn + 2] of longint;
  {  }
  FL : array [1..maxm + maxn + 2] of boolean;
  {      ?}
  PR, ST : array [1..maxm + maxn + 2] of longint;
  {,    BFS}
  m, n, k, s, d, matched, ans : longint;

procedure indata;
var fin : text;
  v1, v2, i : longint;
begin
  assign(fin, infile);
  reset(fin);
  readln(fin); {    }
  read(fin, m, n, k);
  for i := 1 to k do
  begin
    read(fin, v1, v2);
    if NOT G[v1, v2 + m] then
    begin
      G[v1, v2 + m] := true;
      inc(ADJT[v1]);
      ADJ[v1, ADJT[v1]] := v2 + m;
      inc(ADJT[v2 + m]);
      ADJ[v2 + m, ADJT[v2 + m]] := v1;
    end;
  end;
  close(fin);
  s := m + n + 1;
  d := m + n + 2;
  for i := 1 to m do
  begin
    G[s, i] := true;
    inc(ADJT[s]);
    ADJ[s, ADJT[s]] := i;
    inc(ADJT[i]);
    ADJ[i, ADJT[i]] := s;
  end;
  for i := 1 to n do
  begin
    G[i + m, d] := true;
    inc(ADJT[i + m]);
    ADJ[i + m, ADJT[i + m]] := d;
    inc(ADJT[d]);
    ADJ[d, ADJT[d]] := i + m;
  end;
end;

function augment : boolean;
var i, j, stt, sp, l : longint;
begin
  fillchar(PR, sizeof(PR), 0);
  fillchar(FL, sizeof(FL), 0);
  fillchar(ST, sizeof(ST), 0);
  ST[1] := s;
  stt := 1;
  {   }
  sp := 1;
  {   }
  FL[s] := true;
  augment := false;
  repeat
    if FL[d] then break; {  }
    if sp > stt then exit; {    }
    i := ST[sp]; inc(sp);
    for l := 1 to ADJT[i] do
    begin
      j := ADJ[i, l];
      if G[i, j] and NOT FL[j] then
      begin
        FL[j] := true;
        PR[j] := i;
        inc(stt);
        ST[stt] := j;
        {  1 unit    (i,j),  j-tiq   
	     }
      end;
    end;
  until false;
  j := d;
  i := PR[j];
  while j <> s do
  begin
    G[i, j] := NOT G[i, j]; {G[i, j] := FALSE}
    G[j, i] := NOT G[j, i]; {G[j, i] := TRUE}
    j := i;
    i := PR[j];
  end;
  augment := true;
end;

procedure solve;
begin
  while augment do inc(matched);
  ans := n + m - matched; {matched + (n + m - 2 * matched)}
end;

procedure outdata;
var fout : text;
begin
  assign(fout, outfile);
  rewrite(fout);
  writeln(fout, ans);
  close(fout);
end;

begin
  indata;
  solve;
  outdata;
end.