{ This is the input data:  N;  degrees of each vertice;
5
4 3 3 2 2

                            
                          -------------------

            
  ,    .

                                
                                -------
      d[i].
  d[i]   d[1] >= d[2] >= ... d[n].
   d[k]       k  
 d[k]    (     k)  update-
  d[i] ,  D[k]:=0,   d[k] ( k)   1.
    d[i]   ==>      
     d[i] = 0;
                                                           
                                                             1 , 
}

const Max = 100;

type
  TGraph = array[1..Max,1..Max] of boolean;
  TGArray = array[1..Max] of integer;

Var
  G: TGraph;
  D,Index: TGArray;
  N: integer;

procedure ReadGA(const S:string);
Var
 i,j: integer;
 F: Text;
begin
  FillChar(G, SizeOf(G),0);

  assign(F,S); reset(F); readln(F);
  readln(F,N);
  for i:=1 to N do
    Read(F, D[i]);
  for i:=1 to N do
    index[i]:=i;

  close(F);
end;

procedure WriteGraph(Var G:TGraph);
Var
 i,j: integer;
begin
  for i:=1 to N do
    begin
      WriteLn;
        for j:=1 to N do
          write(byte(G[i,j]):2);
    end;
  WriteLn;
end;

procedure Solve;

procedure Sort;
Var
  i,j,x: integer;
begin
  for i:=1 to N-1 do
    for j:=i+1 to N do
      if D[j] > D[i] then
        begin
          X:=D[i];
          D[i]:=D[j];
          D[j]:=X;

          X:=Index[i];
          Index[i]:=Index[j];
          Index[j]:=X;
        end;
end;

Var
  Flag: boolean;
  i,k: integer;

Label
  ExitLoop;

begin
  Flag:=false;

  repeat
    sort;

    k:=index[1];
    if d[1] >= N then goto ExitLoop;

    for i:=2 to d[1]+1 do
      begin
        dec(d[1]);
        G[k,index[i]]:=true;
        G[index[i],k]:=true;
        dec(d[i]);
      end;

    for i:=1 to N do
      if d[i] < 0 then goto ExitLoop;

    for i:=1 to N do
      if d[i] <> 0 then
        break;

    if (i=N) and (d[i] = 0) then
      begin
        Flag:=true;
        goto ExitLoop;
      end;
  until false;

 ExitLoop:

  WriteLn;
  if Flag then
    begin
      WriteLn('  .    :');
      WriteGraph(G);
    end
  else
    WriteLn('   ');
end;


Var
  i: integer;
begin
  ReadGA('CREATE.PAS');
  Solve;
end.
