{  :
4
4 3 -6 5
7

  .     Q   :

  a1*x1 + a2*x2 + ... +an*Xn = b

      

 :
 --------

     (1,2, ... , an)  b.
  '    N ,     
   N-1   ..

}

const
  Max = 100;
  InputFileName = 'DIOF.PAS';

type
  TArray = array[1..Max] of longint;

Var
  A,X,Tmp: TArray;
  B,N,Q: longint;

procedure ReadIt(const S: string);
Var
  F: Text;
  i: integer;
begin
  assign(F,S); reset(F); readln(F);
  readln(F,N);
  for i:=1 to N do read(F,A[i]);
  readln(F);
  readln(F,B);
  close(F);
end;

procedure WriteIt;
Var
  Sum: longint;
  i: word;
begin
  Sum:=0;
  for i:=1 to N do
    begin
      Write(A[i],'*(',X[i],')');
      if i = N then write(' = ') else write(' + ');
      Sum:=Sum+A[i]*X[i];
    end;

  write(B);
  if Sum = B then writeln('     Correct')
  else writeln(^G^G,'      Incorrect');
end;

function Nod(A,B: longint): longint;
Var
  R: longint;
begin
  if A < B then
    begin
      R:=A;
      A:=B;
      B:=R;
    end;

  while B <> 0 do
    begin
      R:=A mod B;
      A:=B;
      B:=R;
    end;

  Nod:=A;
end;

{    }
procedure FindX0Y0(Var X0,Y0: longint; a,b,c,d: longint);
begin
  a:=a div d;  b:=b div d;  c:=c div d;

  X0:=0;

  repeat
    inc(X0);
    if (C - X0*a) mod b = 0 then
      begin
        Y0:=(C-X0*a) div b;
        exit;
      end;
  until false;
end;

function CheckSol: boolean;
Var
 D: longint;
 i: integer;
begin
  D:=A[1];
  for i:=2 to N do
    D:=Nod(D, A[i]);

  CheckSol:=B mod D = 0;
end;

procedure Solve(Q,MyN: longint);
Var
  SaveA: longint;
  X0,Y0: longint;
  d: longint;
begin
  if MyN > 2 then
    begin
      SaveA:=A[MyN-1];
      A[MyN-1]:=1;

      Solve(Q, MyN-1);
      A[MyN-1]:=SaveA;

      d:=nod(A[MyN-1],A[MyN]);
      FindX0Y0(X0,Y0,A[MyN-1],A[MyN],X[MyN-1],d);
      X[MyN-1]:=X0 + (A[MyN+0] div d)*Q;
      X[MyN  ]:=Y0 - (A[MyN-1] div d)*Q;
    end
  else
    begin
      D:= nod(A[1],A[2]);
      FindX0Y0(X0,Y0,A[1],A[2],B,D);
      X[1]:=X0 + (A[2] div d)*Q;
      X[2]:=Y0 - (A[1] div d)*Q;
    end;
end;

Var
  i: longint;
begin
  ReadIt(InputFileName);

  if CheckSol then
    begin
      write('     Q='); readln(Q);

      for i:=1 to Q do
        begin
          Solve(i,N);
          WriteIt;
        end;
    end
  else
    writeln(' ');
end.