/*
                              
                            ---------------

            ,    n   
 ,   n +    .      k,
     k.
         480   { 480, 492, 507, 519,... }.
                .   
     ,      .
        480     483  519      507 
 507,        481.

 )            1,   3  
 9.  ,       n (1<=n<=16384) 
 ,   n        .
 :
 : 86
 :     1  101.

 )     - ,         100 -
  .
  8  -   4  :
  1, 2, 4  8

 )   :      ,    -
   N  .        -
              (. p4.pas 
 .2)   :   (  1, 2, 3,  ..,) -
   1  flows[i],    i   .  -
  N^2     ,   ,    
       N .   ,   
    i,  flows[i] = N.    , ..  
 -      -      
  .     O(n^2).
                                                                 
*/

#include <stdio.h>

#define N 100

int flows[N * N];

int sum( int x )
{
  int a;

  for( a = 0; x; a += x % 10, x /= 10 );

  return a;
}

void main( void )
{
  int i, j, k;

  for( i = 1; flows[i] <= N && i <= N * N; i++ )
    for( j = i, k = 1; flows[j] <= N && j <= N * N; j += sum( j ) )
      flows[j]++;

  for( i = 1; flows[i] != N; i++ );
  printf( "%d\n", i );
}
