/*
                              
                            ---------------

            ,    n   
 ,   n +    .      k,
     k.
         480   { 480, 492, 507, 519,... }.
                .   
     ,      .
        480     483  519      507 
 507,        481.

 )            1,   3  
 9.  ,       n (1<=n<=16384) 
 ,   n        .
 :
 : 86
 :     1  101.

 )     - ,         100 -
  .
  8  -   4  :
  1, 2, 4  8

 )   :     flowb1.c,      - -
     .   ,    flows[i] = 0,   ,  
     ,  ..       -
  (,     .)      ,   
     i   i + sum( i ) -    
    .     :      
            
 ,         .    
 :
 flows[1] = 1, flows[2] = 2, flows[4] = 3,...
   1    ,  2     1 
   -  2  ..
          :       ? -
   ,   flows[i] <> 0,     i  -
    , ..     .  
        .      ,  
       flowb1.c,    ,
  O(n)   - .
                                                                 
*/

#include <stdio.h>

#define N 100

int flows[N * N];

int sum( int x )
{
  int a;

  for( a = 0; x; a += x % 10, x /= 10 );

  return a;
}

int main( void )
{
  int i, j, k;

  for( i = 1; flows[i] <= N; i++ )
    if( !flows[i] )
      for( j = i, k = 0; flows[j] <= N; j += sum( j ) )
        if( !flows[j] )
          flows[j] = ++k;
        else
          flows[j] += k;

  for( i = 1; flows[i] != N; i++ );
  printf( "%d\n", i );

  return 0;
}
