{ This is the input data:  N;  P1;  p2;  pN...
  11
 3
 1
 100
 301
 400
 300
 50
 100
 202
 48
 1
                           1  
                           ------------------

                      ,
                   (4-, ) , 1999 .

       .     N   .  
         ,       -
      1 .     N <= 50
   W[1,2,...N]    (W[1,2,...N] <=1000)   -
  .      1  (1000 )   
     (   )  "NO"  
 .

                               
                               -------

           .
      Can[k,KG] = true      k ,
   KG .  Can[k,KG]     :
         Can[0,0]  = true
	 Can[k,KG] = true
	    Can[k-1,KG-W[k]]        ( k- )
	     Can[k-1,KG] = true  ( k- )
	  Can[k,KG] = false
        Can[N,1000].
    :   K     -
 ,     KG    :
   -         k    k-1 -
     ,     KG-W[i].
   -          k     k-1
     ,      KG.
                 1000 -
              
 Can[0..N,0..1000].   Take[k,KG]      k
      k    KG.  
          Can.   
   -  ,       -
      Can[0][1..1000],   Can[1][0..1000],
  Can[1][0..1000]  ..  Can[N][0..1000].   :
    Can[0...N][0...1000] = false;
    Take[0...N][0...1000] = false;
    Can[0,0] = true;
     k = 1 ... N               //    k 
       Can[k][0...1000] = Can[k-1][0...1000];
        weight = W[k] ... KG   //    weight
          Can[k-1][weight-W[k]] then    //   K
             Can[k][weight]  = true;
             Take[k][weight] = true;
         1000 :
    KG = 1000;
     Can[N,KG] = false,  
     
      
          Take[N]^[KG] 
           KG = Kg - W[N];  W[N]  //  N 
         N = N-1
       N = 0;
            
    M*N*2 ,     M*N/4 ,   M  -
    (1000),  N   .    -
      O(N*M).

                                                                
                                                             , 1999
}

CONST InFileName  = 'FRUITS.PAS';
      OutFileName = '';
      MaxN  = 50;
      MaxKG = 1000;
      KG: word = 1000;

TYPE TRow = array[0..MaxKG] of boolean;

VAR N: integer;
    W: array[1..MaxN] of integer;

    Can,Take: array[0..MaxN] of ^TRow;


Procedure ReadData; { Read the input data - N and W[1..N] }
Var F: Text;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    ReadLn(F,W[N]);
  Close(F);
End;


Procedure CalculateF;
Var k,weight: integer;
Begin
  for k:= 0 to N do
     begin
       New(Can[k]); FillChar(Can[k]^,SizeOf(Can[k]^),false);
       New(Take[k]); FillChar(Take[k]^,SizeOf(Take[k]^),false);
     end;
  Can[0]^[0]:=true;
  for k:= 1 to N do
    begin {         K  }
      Can[k]^:= Can[k-1]^;
      for weight:= W[k] to KG do
        if Can[k-1]^[weight-W[k]] then
          begin {   K }
            Can[k]^[weight]:= true;
            Take[k]^[weight]:= true;
          end;
    end;
End;


Procedure PrintSolution;
Var OutF: Text;
    i: integer;
  Procedure PrintFruits;
  Var i: integer;
  Begin
    repeat
      if Take[N]^[KG] then
        begin Dec(KG,W[N]); WriteLn(OutF,W[N]); end;
      Dec(N);
    until N = 0;
    Close(OutF); Halt;
  End;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  if Can[N]^[KG] then
    PrintFruits
  else WriteLn(OutF,'NO');
  Close(OutF);
End;


BEGIN
  ReadData;
  CalculateF;
  PrintSolution;
END.
