/*
    , 8-10  2002

 1 ( 11-12 )   (Genom)

           ,
     A, C, G  T.    
          ,   
      ,    . 
           
    N (5N1000) ,     -
 255 .        
   ,      , ..  
   ,    . 
        .  
GENOM.EXE,    N   .

     GENOM.INP    N.   
 N    ,     N- .
        ,      
    .

  GENOM.OUT      N ,    
         ,  ,  
     ,    
.            , 
     ,      
  .          
   .        
   ,          
.

:
GENOM.INP
5
TGCCGT
GCCCGA
AGGTGC
TGGA
AGCC

GENOM.OUT
3
-5
1
-2
4

:

      backtrack.     
             
     (   -   )  
         .  ,  
     .
    ,       
 -:
    ,       ( 
    )      (
        )  
.  : )
 (     )        
  .  : )

  source  doit     backtrack-.
    :
a        .
 ,     -:
   b          .
   c        -  .
  ,     -:
   d          .
   e        -  .
            
 .   :
ACGTGGTCGAGT           CTGGTGCA
   GAGT, ..        
.
  1        0      .

     :
gen[][]   
len[]      (      )
used[]         .
beg[]         .
begs     .
ent[] -        .
ents     .

       ( - ) 
    X   X,     
X+1024.

 

*/

#include <stdio.h>
#include <string.h>

FILE *fn;
int n;
char gen[2048][256];
int len[2048];
int used[1024];
int beg[1024], begs;
int ent[1024], ents;

int doit(int a, int b, int c, int d, int e) {
  int i, j;

  if (a==0) {
    if (c==0 && e==0) return 1;
    else if (c==0) {
      if (d>1024) {
        return !memcmp(gen[d-1024], &gen[d][len[d]-e], e);
      } else {
        return !memcmp(gen[d+1024], &gen[d][len[d]-e], e);
      }
    } else {
      if (b>1024) {
        return !memcmp(gen[b-1024], &gen[b][len[b]-c], c);
      } else {
        return !memcmp(gen[b+1024], &gen[b][len[b]-c], c);
      }
    }
  } else {
    if (c==0 && e==0) {
      if (a==1) {
        for (i=1; i<=n; i++) if (!used[i]) break;
        if (!memcmp(gen[i], gen[i+1024], len[i])) {
          beg[begs]=i;
          begs++;
          return 1;
        } else return 0;
      }
      for (i=1; i<n; i++) if (!used[i]) {
        for (j=i+1; j<=n; j++) if (!used[j]) {
          if (len[i]<len[j]) {
            if (!memcmp(gen[i], gen[j], len[i])) {
              used[i]=1;
              beg[begs]=i;
              begs++;
              used[j]=1;
              ent[ents]=j;
              ents++;
              if (doit(a-2, 0, 0, j, len[j]-len[i])) return 1;
              else {
                used[i]=0;
                begs--;
                used[j]=0;
                ents--;
              }
            }
            if (!memcmp(gen[i], gen[j+1024], len[i])) {
              used[i]=1;
              beg[begs]=i;
              begs++;
              used[j]=1;
              ent[ents]=-j;
              ents++;
              if (doit(a-2, 0, 0, j+1024, len[j]-len[i])) return 1;
              else {
                used[i]=0;
                begs--;
                used[j]=0;
                ents--;
              }
            }
            if (!memcmp(gen[i+1024], gen[j], len[i])) {
              used[i]=1;
              beg[begs]=-i;
              begs++;
              used[j]=1;
              ent[ents]=j;
              ents++;
              if (doit(a-2, 0, 0, j, len[j]-len[i])) return 1;
              else {
                used[i]=0;
                begs--;
                used[j]=0;
                ents--;
              }
            }
            if (!memcmp(gen[i+1024], gen[j+1024], len[i])) {
              used[i]=1;
              beg[begs]=-i;
              begs++;
              used[j]=1;
              ent[ents]=-j;
              ents++;
              if (doit(a-2, 0, 0, j+1024, len[j]-len[i])) return 1;
              else {
                used[i]=0;
                begs--;
                used[j]=0;
                ents--;
              }
            }
          } else {
            if (!memcmp(gen[j], gen[i], len[j])) {
              used[j]=1;
              beg[begs]=j;
              begs++;
              used[i]=1;
              ent[ents]=i;
              ents++;
              if (doit(a-2, 0, 0, i, len[i]-len[j])) return 1;
              else {
                used[j]=0;
                begs--;
                used[i]=0;
                ents--;
              }
            }
            if (!memcmp(gen[j], gen[i+1024], len[j])) {
              used[j]=1;
              beg[begs]=j;
              begs++;
              used[i]=1;
              ent[ents]=-i;
              ents++;
              if (doit(a-2, 0, 0, i+1024, len[i]-len[j])) return 1;
              else {
                used[j]=0;
                begs--;
                used[i]=0;
                ents--;
              }
            }
            if (!memcmp(gen[j+1024], gen[i], len[j])) {
              used[j]=1;
              beg[begs]=-j;
              begs++;
              used[i]=1;
              ent[ents]=i;
              ents++;
              if (doit(a-2, 0, 0, i, len[i]-len[j])) return 1;
              else {
                used[j]=0;
                begs--;
                used[i]=0;
                ents--;
              }
            }
            if (!memcmp(gen[j+1024], gen[i+1024], len[j])) {
              used[j]=1;
              beg[begs]=-j;
              begs++;
              used[i]=1;
              ent[ents]=-i;
              ents++;
              if (doit(a-2, 0, 0, i+1024, len[i]-len[j])) return 1;
              else {
                used[j]=0;
                begs--;
                used[i]=0;
                ents--;
              }
            }
          }
        }
      }
    } else if (c==0) {
      for (i=1; i<=n; i++) if (!used[i]) {
        if (len[i]<=e) {
          if (!memcmp(gen[i], &gen[d][len[d]-e], len[i])) {
            used[i]=1;
            beg[begs]=i;
            begs++;
            if (doit(a-1, 0, 0, d, e-len[i])) return 1;
            else {
              used[i]=0;
              begs--;
            }
          }
          if (!memcmp(gen[i+1024], &gen[d][len[d]-e], len[i])) {
            used[i]=1;
            beg[begs]=-i;
            begs++;
            if (doit(a-1, 0, 0, d, e-len[i])) return 1;
            else {
              used[i]=0;
              begs--;
            }
          }
        } else {
          if (!memcmp(gen[i], &gen[d][len[d]-e], e)) {
            used[i]=1;
            beg[begs]=i;
            begs++;
            if (doit(a-1, i, len[i]-e, 0, 0)) return 1;
            else {
              used[i]=0;
              begs--;
            }
          }
          if (!memcmp(gen[i+1024], &gen[d][len[d]-e], e)) {
            used[i]=1;
            beg[begs]=-i;
            begs++;
            if (doit(a-1, i+1024, len[i]-e, 0, 0)) return 1;
            else {
              used[i]=0;
              begs--;
            }
          }
        }
      }
    } else {
      for (i=1; i<=n; i++) if (!used[i]) {
        if (len[i]<=c) {
          if (!memcmp(gen[i], &gen[b][len[b]-c], len[i])) {
            used[i]=1;
            ent[ents]=i;
            ents++;
            if (doit(a-1, b, c-len[i], 0, 0)) return 1;
            else {
              used[i]=0;
              ents--;
            }
          }
          if (!memcmp(gen[i+1024], &gen[b][len[b]-c], len[i])) {
            used[i]=1;
            ent[ents]=-i;
            ents++;
            if (doit(a-1, b, c-len[i], 0, 0)) return 1;
            else {
              used[i]=0;
              ents--;
            }
          }
        } else {
          if (!memcmp(gen[i], &gen[b][len[b]-c], c)) {
            used[i]=1;
            ent[ents]=i;
            ents++;
            if (doit(a-1, 0, 0, i, len[i]-c)) return 1;
            else {
              used[i]=0;
              ents--;
            }
          }
          if (!memcmp(gen[i+1024], &gen[b][len[b]-c], c)) {
            used[i]=1;
            ent[ents]=-i;
            ents++;
            if (doit(a-1, 0, 0, i+1024, len[i]-c)) return 1;
            else {
              used[i]=0;
              ents--;
            }
          }
        }
      }
    }
  }
  return 0;
}

int main(void) {
int i, j;

fn=fopen("GENOM.INP", "r");
fscanf(fn, "%d\n", &n);
for (i=1; i<=n; i++) {
  fscanf(fn, "%s\n", &gen[i]);
  len[i+1024]=len[i]=strlen(gen[i]);
  for (j=0; j<len[i]; j++) {
    gen[i+1024][len[i]-j-1]=gen[i][j];
  }
}
fclose(fn);

doit(n, 0, 0, 0, 0);

fn=fopen("GENOM.OUT", "w");
for (i=0; i<begs; i++) {
  fprintf(fn, "%d\n", beg[i]);
}
for (j=ents-1; j>=0; j--) {
  fprintf(fn, "%d\n", -ent[j]);
}
fclose(fn);

return 0;
}
