/*
NAME: Ivan Anev
PROG: invest
LANG: C


    '02 - 16  2002
  1112  ( A)

 2.  

     x0    . 
         ut ,  
   .       p , 
  (t + 1)-     
                    x(t+1) = xt + (p/100)xt  ut.

  INVEST.EXE,       
   u0 + u1 + u2 + ... + uT1  T  
      ut      t = 0, 1,
2, ..., T  1,    ,   ut    
-    (p/100)xt, .. 0 &lt;= ut  &lt;= (p/100)xt.

            
      .       
,     :   T (  
  1  5000), p (     0.001  20.000,
  - 3    )    x0,
     1000  1000000.

  ( -  )   
            6 
   ,      
 .

.

:

2
10.0
1000

:

200.000000


:

   x  ,  p (0&lt;=p&lt;=1)   
    ,  t     
   k1, k2, . . ., kt       
  (0&lt;=ki&lt;=1).

     j ,       
   - i.       
      x*((1+p)^(j-1))*(1+p*(1-ki))    x*((1+p)^(i-1))*p*ki.
           
           . 
         .

       .
     k1*x*p,
  x*(1+p*(1-k1))*p*k2,
  x*(1+p*(1-k1))*(1+p*(1-k2))*p*k3  ..    
 .        k1, k2, . . ., kt. 
     k1,     k-.
      k1   0  1.  
 k.      k-  0  1.

    ,        , 
     .        . 
,      .        m
.  (m-1)*p>1 ,       
           
    .      
        .     (    
)    .
*/

#include <stdio.h>
#include <math.h>

int t;
double p, x, ans;

int main(void) {
	int m;

	scanf("%d%lf%lf", &t, &p, &x);

	p /= 100.0;
	m = (int)floor(1.0 / p);
	if (m > t-1)
		m = t-1;
	x *= pow(1.0+p, t-1-m);
	ans = x * p * (m+1);

	printf("%.6f\n", ans);

	return 0;
}
