/*
 B1. 

  N ,    1, 2, ..., N,  N  
 ,  -  30000.     
         , 
   . ,      
       .    
        .   ,   
        -    
     ,      ( 
)     ,        
  (  )     .    
     ,   .  
BANK.EXE,             
,       ,      
  .

        .     
  N.         
         I, J  S    
,       , .  
      .        
    -  1 000 000 000 . 

     e   .   
    K      .
 K  ,    K      
         I, J  S    
,       , .  
              0.


 1                      2

:                        :
5                            5 
1 2 100                      1 3 100
2 3 101                      2 4 101
3 4 101                      3 5 100
4 5 101                      4 2 101
5 1 100                      5 1 100
0 0 0                        0 0 0

:                       :
1                            0
2 5 1



   1  
  

       .      ,
           .   
           
 .            
    .

      ,     ,
         .

   ,         ,  
,           .   ,   
               
     .      ,   .

      ,   ,  
  ,      ,    .
     ,      , 
    .        
  ,          
  .     ,    
            
  ,    .      ,  
    ,  ,   .
*/



/*
NAME: Ivan Anev
PROG: bank
LANG: C++
*/

#include <iostream>
#include <cstring>
#include <cstdio>

using namespace std;

const int maxn = 30000;

class Banks {
private:
	int n, tc;
	int b[maxn];
	int t[maxn][3];
public:
	void solve() {
		int i, j, x, y, s;

		memset(b, 0, sizeof(b));
		scanf("%d", &n);
		while (1) {
			scanf("%d%d%d", &x, &y, &s);
			if (x == 0 && y == 0 && s == 0)
				break;
			b[x-1] += s;
			b[y-1] -= s;
		}

		i = j = tc = 0;
		while (1) {
			while (i < n && b[i] <= 0)
				i++;
			while (j < n && b[j] >= 0)
				j++;
			if (i == n)
				break;

			t[tc][0] = i + 1;
			t[tc][1] = j + 1;
			if (b[i] >= abs(b[j])) {
				t[tc++][2] = -b[j];
				b[i] += b[j];
				b[j] = 0;
			}
			else {
				t[tc++][2] = b[i];
				b[j] += b[i];
				b[i] = 0;
			}
		}

		printf("%d\n", tc);
		while (tc-- > 0)
			printf("%d %d %d\n", t[tc][0], t[tc][1], t[tc][2]);
	}
};

Banks banks;

int main() {
	banks.solve();

	return 0;
}
