/*
 B3. 

   .       : 
       ?,   
   ?,       ?
 ..  ,         . , 
      ,       
 .

 P    N , ..      P 
 .  T    (),   M. ,   
T      P,        
-    ,      P. ,
 P=[a,b,a]  T=xaaabayabaaz,     a (7  ),
b (2  ), ab (2  ), ba (2  ), aab (1  ), aba
(2  )  baa (1  )      P,   
  T       P.      
  T   N,       P?  
  P  T   ASCII   32  127 .

  OCCUR.EXE,     P   T 
    T   N,       P.

      .    
N (1 <= N <= 100)  M (3 <= M <= 1 000 000),    .
     N      P.  
 ,    ,    . 

          .





:
3 12
aba
xaaabayabaaz

:
4



   3  
  

    N    T.      
  P    -, b-  ..   .   
     N      
            P.   
    N     .  
      .

         N , 
    x  x+1.       
.             
    -         
,         .
           
N         P.      ,
       .    
           
 N    P    ,    
,            
   .         , 
,     N       P.

,       .     
 ,    -    -.
        -.   
          T.
*/



/*
NAME: Ivan Anev
PROG: occur
LANG: C
*/

#include <iostream>
#include <cstring>

using namespace std;

const int maxn = 100;
const int maxm = 1000000;
const int maxa = 26;

class Occur {
private:
	int n, m;
	char p[maxn], t[maxm];
public:
	void solve() {
		int ac[maxa];
		int i, d, x, c;

		cin >> n >> m >> p >> t;
		memset(ac, 0, sizeof(ac));
		for (i = 0; i < n; i++)
			ac[p[i]-'a']++;
		d = 0;
		for (i = 0; i < maxa; i++)
			if (ac[i] > 0)
				d++;

		c = 0;
		for (i = 0; i < m; i++) {
			x = t[i] - 'a';
			ac[x]--;
			if (ac[x] == 0)
				d--;
			else if (ac[x] == -1)
				d++;

			if (i - n >= 0) {
				x = t[i-n] - 'a';
				ac[x]++;
				if (ac[x] == 0)
					d--;
				else if (ac[x] == 1)
					d++;
			}

			if (d == 0)
				c++;
		}

		cout << c << '\n';
	}
};

Occur occur;

int main() {
	occur.solve();

	return 0;
}
