{ This is the input data:
  4
 0 0
 0 100
 100 100
 100 0
  2
 50 50
 -30 50

                             
                            ---------------------

   (      7-    )

               
 .    ,   -
   N .       M -
 .            -
  .  ,        -
   ,          -
  .
      :         N (3<=N<=1000).  -
  N       -     .  
     M -   .    M
      -    . -
           [-1000..1000].
      :   -  ,    .

                                
                                -------
            -1000  1000  -
    ,    ,   
    ()      : 
  Y     -1000  1000      X-
 ,       . 
   :
    PolygonX  -   [-1000..1000] 
                   begX, endX -  
     (x,y)        
      :
      =  (x >= PolygonY[y].begX)    (x <= PolygonY[y].endX) .
            -
         -
   Y-,       X.     -
            ,  
         .   -
      ,     Y--
     X-.     Y   -
  X- (1  2),   -   ,  -
            
 Y. ,      PolygonY  -
   2000,       - 1000 -
  Y        .     
   (x1,y1)  (x2,y2)    y (y1<=y<=y2).  
  x-     y   :
      x:= x1 + (x2-x1)*(y-y1)/(y2-y1)
              
 y1-y2=0 (  ),      
 ( )     .      -
     - y  x-,    ,  -
       PolygonY[].  
 PolygonY[].begX =   PolygonY[].endX = -.   
   y- Y     x- X   -
        PolygonY[]:
         PolygonY[y]
           x < begX  begX:=x;
           x > endX  endX:=x;
           M,
            .
            -
  .    ,       
        .   
     y- Y        
  :
   (PolygonY[trunc(y)].begX,y) - (PolygonY[trunc(y)].endX,y) -
   (PolygonY[trunc(y)+1].begX,y) - (PolygonY[trunc(y)+1].endX,y)
   y 
   (PolygonY[trunc(y)-1].begX,y) - (PolygonY[trunc(y)-1].endX,y) -
   (PolygonY[trunc(y)].begX,y) - (PolygonY[trunc(y)].endX,y)
   y.
             -
    .   Y-    X-,
      ()  .  -
    X-.     X[1,2,...k]. -
        X-  X[1]  X[2],  -
  X[3]  X[4]  ..       X-  X[2] 
 X[3],  X[4]  X[5]  ..      
 ,        .   -
     ,       
   ,           
   .    ,    
  .           integer,
         .  longint  -
          integer.

                                 
                         .

                                                               
                                                            , 1999
}


CONST InFileName  = 'KRIM.PAS';
      OutFileName = '';
      MaxN        = 1000;
      MaxCoord    = 1000;
      EndLess     = MaxCoord+1;

VAR F: Text;
    CountInside: integer;
    PolygonY: array[-MaxCoord..MaxCoord] of
      record begX,endX:single; end;


Procedure CalculateLine(x1,y1,x2,y2:integer);
{     y- y    
   x-       PolygonY[y] }

  Function min(a,b:integer): integer;
  Begin  if a < b then min:=a else min:=b;  End;

  Function max(a,b:integer): integer;
  Begin  if a > b then max:=a else max:=b;  End;

Var y: integer;
    x: single;
Begin
  if y1 <> y2 then
    for y:= min(y1,y2) to max(y1,y2) do
      with PolygonY[y] do
        begin
          x:= x1 + longint(x2-x1)*(y-y1)/(y2-y1); {  !}
          if x < begX then begX:=x;
          if x > endX then endX:=x;
        end;
End;


Procedure CalculatePolygonY; {   PolygonY[] }
Var N: integer;
    x1,y1,x2,y2,firstX,firstY:integer;
Begin
  { Initialize PolygonY[] }
  for N:= -MaxCoord to MaxCoord do
    with PolygonY[N] do
      begin begX:=EndLess; endX:=-EndLess; end;
  { Calculate PolygonY[] values}
  ReadLn(F);
  ReadLn(F,N);
  ReadLn(F,x2,y2);
  firstX:=x2; firstY:=y2;
  for N:= 1 to N-1 do
    begin
      x1:=x2; y1:=y2;
      ReadLn(F,x2,y2);
      CalculateLine(x1,y1,x2,y2);
    end;
  CalculateLine(x2,y2,firstX,firstY);
End;


Function PointInside(x,y:integer): boolean;
Begin
  with PolygonY[y] do
    PointInside:= (x>=begX) and (x<=endX);
End;


Procedure Solve;
Var M,x,y: integer;
Begin
  CountInside:=0;
  ReadLn(F,M);
  for M:= 1 to M do
    begin
      ReadLn(F,x,y);
      if PointInside(x,y) then
        Inc(CountInside);
    end;
End;


Procedure PrintSolution;
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(CountInside);
  Close(OutF);
End;


BEGIN
  Assign(F,InFileName); Reset(F);
  CalculatePolygonY;
  Solve;
  Close(F);
  PrintSolution;
END.
