{ This is the input data:  N;  M;  i1 j1;  i2 j2; ...;  iM jM;
  5
  7
 1 2
 3 1
 2 3
 2 4
 4 3
 3 5
 4 5
                               
                             -------------------

   (      7-    )

          .      
   ,         . -
   .          -
    ,      :
         "    
              
              "
     :          N -   . 
     M -   ,    . 
    M      -    .
  : 1<=N<=50, 0<=M<=1225.
     :    "NO",     "YES"  . -
   "YES"         N- -
    (    ).

      :     "backtracking",   -
       .     
        (     , -
      -).     ,   
   . ,          
    .        ,  
       ,     (  -
    )   .       , -
    ,     .   
   -          -
          (    -
  ).   ,      , 
         ,   
         .   
        .    -
      :       ,
   -      .     -
              
    - ,      .    -
  ,      -.   
         (  ). 
         . 
    N=128,      .

                                                             
                                                          , 1999
}

CONST InFileName  = 'POZNATI.PAS';
      OutFileName = '';
      MaxN = 128;

TYPE TNode = record
               Count: integer;
               Next: array[1..MaxN] of integer;
             end;

VAR N: integer;
    G: array[1..MaxN] of TNode;
    P: array[1..MaxN,1..MaxN] of boolean;

    S: array[1..MaxN] of integer;
    Rez: array[1..MaxN] of integer;
    Used: array[1..MaxN] of boolean;


Procedure ReadData; {    - N, P[1..N,1..N], G[1..N] }
Var F: Text;
    i, M, v1, v2: integer;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N); ReadLn(F,M);
  FillChar(G,SizeOf(G),0);
  FillChar(P,SizeOf(P),false);
  for i:= 1 to M do
    begin
      ReadLn(F,v1,v2);
      P[v1,v2]:=true; P[v2,v1]:=true;
      with G[v1] do
        begin Inc(Count); Next[Count]:=v2; end;
      with G[v2] do
        begin Inc(Count); Next[Count]:=v1; end;
    end;
  Close(F);
End;


Procedure Sort; {    .    S[1..N] }
Var i,j,Min,Tmp: integer;
Begin
  for i:= 1 to N do S[i]:=i;
  for i:= 1 to N-1 do
    begin
      Min:=i;
      for j:= i+1 to N do
        if G[S[j]].Count < G[S[Min]].Count then Min:=j;
      Tmp:=S[Min]; S[Min]:=S[i]; S[i]:=Tmp;
   end;
End;


Procedure PrintSolution; {       }
Var OutF: Text;
    i: integer;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,'YES');
  for i:= 1 to N-1 do
    Write(OutF,Rez[i],' ');
  WriteLn(OutF,Rez[N]);
  Close(OutF);
  Halt;
End;


Procedure Gener(Index:integer); {     }

  Function Check: boolean; {     }
  Var i,j,Chovek: integer;
  Begin
    Chovek:=Rez[Index];
  {     Chovek,      
      i,      , .. Used[i]=false }
    with G[Chovek] do
      for i:= 1 to Count do
        if not Used[Next[i]] then { 'i'   'Chovek'}
          for j:= i+1 to Count do
            if not Used[Next[j]] then { 'j'   'Chovek'}
              if not P[Next[i],Next[j]] then { 'i' i 'j'   }
                begin Check:=false; Exit; end; {  }
    Check:=true;
  End;

Var i: integer;
Begin
  if Index > N then
    PrintSolution; {   N ,   }
  for i:= 1 to N do
    if not Used[S[i]] then
      begin {     Index    }
        Used[S[i]]:=true;
        Rez[Index]:=S[i];
        if Check then
          Gener(Index+1);
        Used[S[i]]:=false;
      end;
End;


Procedure NoSolution; {        }
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,'NO');
  Close(OutF);
  Halt;
End;


BEGIN
  ReadData;
  Sort;
  FillChar(Used,SizeOf(Used),false);
  Gener(1);

  NoSolution;
END.
