{     - N, M;  M    :
 4 4
0 2
0 1
0 3
1 3
                              
                             -----------------

    (      7-    )

          G=(V,E).        -
    G.     T=(V,E'),    -
 : E'  E;         T;   E'  -
  .         :  
      N, M -        (2<=N<=20).
     M       .   -
        -   .   
   1 000 000.

      :           -
  -     .        N 
 ( N*N/2 )      N^(N-2),  , 
   -        . 
      "   " (backtracking) 
       -  .    
            .   
           -
            
        .     
     ,       
           .   -
     ,         -
     ,        -
  .     ,     -
   -          -
 .           
      ,         -
 ,      .    
             
 ,     -         -
  ,        , ..   
     .     -
 ,    .  ,  -
    Find    - v  BeginNext. -
  ,      v,   , 
       ,    BeginNext    -
   v.          v, -
    (    BeginNext)     
    v  .   ,  , 
        v       -
          - ,   -
   v+1     -   .  
 -      -  -,   -.

                                                                
                                                             , 1999
}

{$R-,S-,Q-}

CONST InFileName  = 'TREESCNT.PAS';
      OutFileName = '';
      MaxN = 32;


VAR G: array[0..MaxN-1] of record
         Br: integer;
         next: array[1..maxN] of integer;
       end;
    N, M: integer;

    TreesCount: longint;
    Poseten: array[0..MaxN-1] of boolean;
    Ostavat: integer;
    InTree: array[1..MaxN] of integer;
    BrInTree: integer;


Procedure ReadData; {    - N, M, G[1..N] }
Var F: Text;
    i, v1, v2: integer;
Begin
  FillChar(G,SizeOf(G),0);
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N,M);
  for i:= 1 to M do
    begin
      ReadLn(F,v1,v2);
      with G[v1] do
        begin Inc(Br); next[Br]:=v2; end;
      with G[v2] do
        begin Inc(Br); next[Br]:=v1; end;
    end;
  Close(F);
End;


Procedure Put(v:integer); {   v     }
Begin
  Inc(BrInTree); InTree[BrInTree]:=v;
  Poseten[v]:=true; Dec(Ostavat);
End;


Procedure Remove(v:integer); {   v     }
Begin
  Poseten[v]:=false; Inc(Ostavat);
  Dec(BrInTree);
End;


Procedure Find(v, BeginNext: integer); {    }
Var i,x: integer;
Begin
  with G[ InTree[v] ] do
    for i:= BeginNext to Br do
      if not Poseten[next[i]] then
        begin
          Put(next[i]);
          if Ostavat = 0 then
            Inc(TreesCount);
          Find(v,i+1);
          for x:= v+1 to BrInTree do
            Find(x,1);
          Remove(next[i]);
        end;
End;


Procedure Solve; {       }
Var i: integer;
Begin
  TreesCount:=0; Ostavat:=N-1;
  FillChar(Poseten,SizeOf(Poseten),false);
  BrInTree:=1; InTree[1]:=0;
  Poseten[0]:=true;
  Find(1,1);
End;


Procedure WriteResult; {       }
Var OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  WriteLn(OutF,TreesCount);
  Close(OutF);
End;


BEGIN
  ReadData;
  Solve;
  WriteResult;
END.
